<?php

/*
Copyright (C) 2012, 2013 by the Free Software Foundation, Inc. http://www.fsf.org/

This file is part of ReadingRecord.
Created & developed by Eric Sisler <lbylnxgek@gmail.com>

ReadingRecord is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

ReadingRecord is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with ReadingRecord. If not, see http://www.gnu.org/licenses/.
*/

// Subversion: $Id: classes.php 466 2013-02-25 22:12:22Z esisler $

class ReadingRecord {

    
    function __construct( $progId ) {
        
        // Load config file based on hostname in URL.
        require 'config/' . $_SERVER['HTTP_HOST'] . '_config.php';
        
        // Set program ID.
        $this->progId = $progId;
        
        // Import global configuration array from config file, mostly DB credentials.
        $this->configGlobal = $configGlobal;
        
        // Add global configuration variables from DB.
        $dbLink = mysql_connect( $this->configGlobal['dbHost'], $this->configGlobal['dbUser'], $this->configGlobal['dbPasswd'] );
        mysql_select_db($this->configGlobal['dbConfig'], $dbLink);
        $sql = "SELECT * FROM `global`;";
        $results = mysql_query($sql, $dbLink);
        foreach ( mysql_fetch_assoc( $results ) as $key=>$value ) {
           $this->configGlobal[$key] = $value;
        }
        
        //print var_dump( $this->configGlobal );
        //exit();
        
        // Import program configuration from DB.
        if ( is_numeric ( $this->progId )) {
            $dbLink = mysql_connect( $this->configGlobal['dbHost'], $this->configGlobal['dbUser'], $this->configGlobal['dbPasswd'] );
            mysql_select_db($this->configGlobal['dbConfig'], $dbLink);
            $sql = "SELECT * FROM `program` WHERE `progId` = " . $this->progId . ";";
            $results = mysql_query($sql, $dbLink);
            $this->configProg = mysql_fetch_assoc( $results );
            
            // Set DB based on program ID.
            $this->configProg['dbName'] = $this->configGlobal['db' . $this->progId];
        }
        
        //print var_dump( $this->configProg );
        //exit();
        
        // FIXME: Validate program ID?
        
    // End function __construct
    }


    function allowSelfRegistration( $progId ) {
        
        $configProg = $this->getProgConfig( $progId );
        
        if (( $this->dateOffset( 'Y-m-d' ) >= $configProg['regStart'] ) and ( $this->dateOffset( 'Y-m-d' ) <= $configProg['regEnd'] )) {
                return ( 1 );
        }
        else {
            return ( 0 );
        }
        
    // End function allowSelfRegistration
    }
    
    
    function bodyColor() {
        return ( $this->configGlobal['bodyColor'] );
    }
    
    
    private function checkDupRegistration( $formData, $user, $progId ) {
        
        // Check each program for duplicate registration.
        foreach ( array ( 1, 2, 3, 4, 5, 6 ) as $tempProgId ) {
            
            // Program must be enabled.
            // Don't check current program ID, otherwise registrations can't be updated.
            if (( $this->configGlobal['enable' . $tempProgId ] == '1' ) and ( $tempProgId != $progId )) {
                
                $configProg = $this->getProgConfig( $tempProgId );
                $dbLink = $this->dbReportAccess( $tempProgId );
                
                $sql = "SELECT * FROM `reader` WHERE
                    `first_name` = '" . mysql_real_escape_string($formData['first_name'], $dbLink ) .
                    "' AND `last_name` = '" . mysql_real_escape_string($formData['last_name'], $dbLink ) .
                    "' AND `phone` = '" . mysql_real_escape_string( $formData['phone'], $dbLink ) . "';";                
                
                mysql_query( $sql, $dbLink );
                $recordCount = mysql_affected_rows( $dbLink );
                
                // If matching record, redirect to error page
                if ( $recordCount != '0' ) {
                    // Staff error page.
                    if ( $user == 'staff' ) {
                        header( 'Location: /staff/duplicateRegistration.php' );
                        exit();
                    }
                    // Patron error page.
                    else {
                        header( 'Location: /duplicateRegistration.php' );
                        exit();
                    }
                }
            }
        }
        // Close the MySQL connection, which gets left at the last DB checked.
        // This can cause the wrong DB to be selected later and has cause records to
        // be inserted into the wrong DB!
        mysql_close( $dbLink );
        
    // End function checkDupRegistration
    }


    protected function countReaders( $progId ) {
        
        // FIXME: This method should return 0 if DB credentials are invalid.
        
        $dbLink = $this->dbReportAccess( $progId );
        
        $sql = "SELECT COUNT(*) AS 'count' FROM `reader` LIMIT 1;";
        $results = mysql_query( $sql, $dbLink );
        
        $count = mysql_fetch_assoc( $results );
        return( number_format( $count['count'] ));
        
    // End function countReaders
    }
    
    
    function countReadersByAge( $progId, $format ) {
        
        $libraries = $this->getLibraries();
        $ages = $this->getAges();
        
        $dbLink = $this->dbReportAccess( $progId );
        
        // Tracking by age enabled, so show report.
        if ( $this->configProg['useAge'] == '1' ) {
            print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
            print '<h2 align="center">Count of Readers by Age</h2>' . "\n";
            print '<h3 align="center"> as of ' .$this->dateOffset( 'Y-m-d g:ia' ) . '</h3>' . "\n";
            
            if ( $format == 'dw' ) {
                print '<pre>' . "\n";
                print '===== Registered readers by age =====' . "\n\n";
                print '==== All Libraries ====' . "\n\n";
                print '^  Age  ^  Readers  ^' . "\n";
            }
            else {
                print '<table align="center" cellpadding="7" border="4">' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td colspan="2"><font color="white"><b>All Libraries</b></font></td>' . "\n";
                print '</tr>' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td><font color="white"><b>Age</b></font></td>' . "\n";
                print '<td><font color="white"><b>Readers</b></font></td>' . "\n";
                print '</tr>' . "\n";
            }
            
            // All libraries.
            $ageTotal = '0';
            foreach ( $ages as $ageId=>$ageDesc ) {
                if ( is_numeric( $ageId )) {
                    
                    $sql = "SELECT COUNT(*) AS 'count'
                        FROM `reader`
                        WHERE reader.age_id = $ageId
                        LIMIT 1;";
                    $results = mysql_query( $sql, $dbLink );
                    
                    $recs = mysql_fetch_assoc( $results );
                    $ageTotal += $recs['count'];
                   
                    if ( $format == 'dw' ) {
                        print '| ' . $ageDesc . '  |  ' . number_format( $recs['count'] ) . ' |' . "\n";
                    }
                    else {
                        print '<tr>' . "\n";
                        print '<td>' . $ageDesc . '</td>' . "\n";
                        print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                        print '</tr>' . "\n";
                   }
                }
            }
            
            if ( $format == 'dw' ) {
                print '^ Total  ^  ' . number_format( $ageTotal ) . ' ^' . "\n\n";
            }
            else {
                print '<tr>' . "\n";
                print '<td><b>Total</b></td>' . "\n";
                print '<td align="right"><b>' . number_format( $ageTotal ) . '</b></td>' . "\n";
                print '</tr>' . "\n";
                print '</table><br>' . "\n";
            }
            
            // Sub-total by library.
            foreach ( $libraries as $libraryId=>$libraryDesc ) {
                if ( is_numeric( $libraryId )) {
                    
                    if ( $format == 'dw' ) {
                        print '==== ' . $libraryDesc . ' ====' . "\n\n";
                        print '^  Age  ^  Readers  ^' . "\n";
                    }
                    else {
                        print '<table align="center" cellpadding="7" border="4">' . "\n";
                        print '<tr align="center" bgcolor="black">' . "\n";
                        print '<td colspan="2"><font color="white"><b>' . $libraryDesc . '</b></font></td>' . "\n";
                        print '</tr>' . "\n";
                        print '<tr align="center" bgcolor="black">' . "\n";
                        print '<td><font color="white"><b>Age</b></font></td>' . "\n";
                        print '<td><font color="white"><b>Readers</b></font></td>' . "\n";
                        print '</tr>' . "\n";
                    }
                    
                    $ageTotal = '0';
                    foreach ( $ages as $ageId=>$ageDesc ) {
                        if ( is_numeric( $ageId )) {
                            
                            $sql = "SELECT library.library_id, library.desc, COUNT(*) AS 'count'
                                FROM `library`, `reader`
                                WHERE reader.library_id = library.library_id
                                AND reader.age_id = $ageId
                                AND library.library_id = $libraryId
                                LIMIT 1;";
                            $results = mysql_query( $sql, $dbLink );
                            
                            $recs = mysql_fetch_assoc( $results );
                            $ageTotal += $recs['count'];
                            
                            if ( $format == 'dw' ) {
                                print '| ' . $ageDesc . '  |  ' . number_format( $recs['count'] ) . ' |' . "\n";
                            }
                            else {
                                print '<tr>' . "\n";
                                print '<td>' . $ageDesc . '</td>' . "\n";
                                print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                                print '</tr>' . "\n";
                            }
                        }
                    }
                    
                    if ( $format == 'dw' ) {
                        print '^ Total  ^  ' . number_format( $ageTotal ) . ' ^' . "\n\n";
                    }
                    else {
                        print '<tr>' . "\n";
                        print '<td><b>Total</b></td>' . "\n";
                        print '<td align="right"><b>' . number_format( $ageTotal ) . '</b></td>' . "\n";
                        print '</tr>' . "\n";
                        print '</table><br>' . "\n";
                    }
                }
            }
            if ( $format == 'dw' ) {
                print '</pre>' . "\n";
            }
        }
        // Tracking by age disabled, display error message.
        else {
            print '<h2 align="center"><font color="red">Tracking by age is disabled for this program.</font></h2>' . "\n";
        }
        
    // End function countReadersByAge
    }
    
    
    function countReadersByCity( $progId, $format ) {
        
        $libraries = $this->getLibraries();
        $cities = $this->getCities();
        
        $dbLink = $this->dbReportAccess( $progId );
        
        // Tracking by city enabled, so show report.
        if ( $this->configProg['useCity'] == '1' ) {
            print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
            print '<h2 align="center">Count of Readers by City</h2>' . "\n";
            print '<h3 align="center"> as of ' . $this->dateOffset( 'Y-m-d g:ia' ) . '</h3>' . "\n";
            
            if ( $format == 'dw' ) {
                print '<pre>' . "\n";
                print '===== Registered readers by city =====' . "\n\n";
                print '==== All Libraries ====' . "\n\n";
                print '^  City  ^  Readers  ^' . "\n";
            }
            else {
                print '<table align="center" cellpadding="7" border="4">' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td colspan="2"><font color="white"><b>All Libraries</b></font></td>' . "\n";
                print '</tr>' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td><font color="white"><b>City</b></font></td>' . "\n";
                print '<td><font color="white"><b>Readers</b></font></td>' . "\n";
                print '</tr>' . "\n";
            }
            
            // All libraries.
            $cityTotal = '0';
            foreach ( $cities as $cityId=>$cityDesc ) {
                if ( is_numeric( $cityId )) {
                    
                    $sql = "SELECT COUNT(*) AS 'count'
                        FROM `reader`
                        WHERE reader.city_id = $cityId
                        LIMIT 1;";
                    $results = mysql_query( $sql, $dbLink );
                    
                    $recs = mysql_fetch_assoc( $results );
                    $cityTotal += $recs['count'];
                    
                    if ( $format == 'dw' ) {
                        print '| ' . $cityDesc . '  |  ' . number_format( $recs['count'] ) . ' |' . "\n";
                    }
                    else {
                        print '<tr>' . "\n";
                        print '<td>' . $cityDesc . '</td>' . "\n";
                        print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                        print '</tr>' . "\n";
                    }
                }
            }
            
            if ( $format == 'dw' ) {
                print '^ Total  ^  ' . number_format( $cityTotal ) . ' ^' . "\n\n";
            }
            else {
                print '<tr>' . "\n";
                print '<td><b>Total</b></td>' . "\n";
                print '<td align="right"><b>' . number_format( $cityTotal ) . '</b></td>' . "\n";
                print '</tr>' . "\n";
                print '</table><br>' . "\n";
            }
            
            // Sub-total by library.
            foreach ( $libraries as $libraryId=>$libraryDesc ) {
                if ( is_numeric( $libraryId )) {
                    
                    if ( $format == 'dw' ) {
                        print '==== ' . $libraryDesc . ' ====' . "\n\n";
                        print '^  City  ^  Readers  ^' . "\n";
                    }
                    else {
                        print '<table align="center" cellpadding="7" border="4">' . "\n";
                        print '<tr align="center" bgcolor="black">' . "\n";
                        print '<td colspan="2"><font color="white"><b>' . $libraryDesc . '</b></font></td>' . "\n";
                        print '</tr>' . "\n";
                        print '<tr align="center" bgcolor="black">' . "\n";
                        print '<td><font color="white"><b>City</b></font></td>' . "\n";
                        print '<td><font color="white"><b>Readers</b></font></td>' . "\n";
                        print '</tr>' . "\n";
                    }
                    
                    $cityTotal = '0';
                    foreach ( $cities as $cityId=>$cityDesc ) {
                        if ( is_numeric( $cityId )) {
                            
                            $sql = "SELECT library.library_id, library.desc, COUNT(*) AS 'count'
                                FROM `library`, `reader`
                                WHERE reader.library_id = library.library_id
                                AND reader.city_id = $cityId
                                AND library.library_id = $libraryId
                                LIMIT 1;";
                            $results = mysql_query( $sql, $dbLink );
                            
                            $recs = mysql_fetch_assoc( $results );
                            $cityTotal += $recs['count'];
                            
                            if ( $format == 'dw' ) {
                                print '| ' . $cityDesc . '  |  ' . number_format( $recs['count'] ) . ' |' . "\n";
                            }
                            else {
                                print '<tr>' . "\n";
                                print '<td>' . $cityDesc . '</td>' . "\n";
                                print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                                print '</tr>' . "\n";
                            }
                        }
                    }
                    
                    if ( $format == 'dw' ) {
                        print '^ Total  ^  ' . number_format( $cityTotal ) . ' ^' . "\n\n";
                    }
                    else {
                        print '<tr>' . "\n";
                        print '<td><b>Total</b></td>' . "\n";
                        print '<td align="right"><b>' . number_format( $cityTotal ) . '</b></td>' . "\n";
                        print '</tr>' . "\n";
                        print '</table><br>' . "\n";
                    }
                    
                }
            }
            if ( $format == 'dw') {
                print '</pre>' . "\n";
            }
        }
        // Tracking by city disabled, display error message.
        else {
            print '<h2 align="center"><font color="red">Tracking by city is disabled for this program.</font></h2>' . "\n";
        }
        
    // End function countReadersByCity
    }
    
    
    function countReadersByGrade( $progId, $format ) {
        
        $libraries = $this->getLibraries();
        $grades = $this->getGrades();
        
        $dbLink = $this->dbReportAccess( $progId );
        
        // Tracking by grade enabled, so show report.
        if ( $this->configProg['useGrade'] == '1' ) {
            print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
            print '<h2 align="center">Count of Readers by Grade</h2>' . "\n";
            print '<h3 align="center"> as of ' . $this->dateOffset( 'Y-m-d g:ia' ) . '</h3>' . "\n";
            
            if ( $format == 'dw' ) {
                print '<pre>' . "\n";
                print '===== Registered readers by grade =====' . "\n\n";
                print '==== All Libraries ====' . "\n\n";
                print '^  Grade  ^  Readers  ^' . "\n";
            }
            else {
                print '<table align="center" cellpadding="7" border="4">' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td colspan="2"><font color="white"><b>All Libraries</b></font></td>' . "\n";
                print '</tr>' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td><font color="white"><b>Grade</b></font></td>' . "\n";
                print '<td><font color="white"><b>Readers</b></font></td>' . "\n";
                print '</tr>' . "\n";
            }
            
            // All libraries.
            $gradeTotal = '0';
            foreach ( $grades as $gradeId=>$gradeDesc ) {
                if ( is_numeric( $gradeId )) {
                    
                    $sql = "SELECT COUNT(*) AS 'count'
                        FROM `reader`
                        WHERE reader.grade_id = $gradeId
                        LIMIT 1;";
                    $results = mysql_query( $sql, $dbLink );
                    
                    $recs = mysql_fetch_assoc( $results );
                    $gradeTotal += $recs['count'];
                    
                    if ( $format == 'dw' ) {
                        print '| ' . $gradeDesc . '  |  ' . number_format( $recs['count'] ) . ' |' . "\n";
                    }
                    else {
                        print '<tr>' . "\n";
                        print '<td>' . $gradeDesc . '</td>' . "\n";
                        print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                        print '</tr>' . "\n";
                    }
                }
            }
            
            if ( $format == 'dw' ) {
                print '^ Total  ^  ' . number_format( $gradeTotal ) . ' ^' . "\n\n";
            }
            else {
                print '<tr>' . "\n";
                print '<td><b>Total</b></td>' . "\n";
                print '<td align="right"><b>' . number_format( $gradeTotal ) . '</b></td>' . "\n";
                print '</tr>' . "\n";
                print '</table><br>' . "\n";
            }
            
            // Sub-total by library.
            foreach ( $libraries as $libraryId=>$libraryDesc ) {
                if ( is_numeric( $libraryId )) {
                    
                    if ( $format == 'dw' ) {
                        print '==== ' . $libraryDesc . ' ====' . "\n\n";
                        print '^  Grade  ^  Readers  ^' . "\n";
                    }
                    else {
                        print '<table align="center" cellpadding="7" border="4">' . "\n";
                        print '<tr align="center" bgcolor="black">' . "\n";
                        print '<td colspan="2"><font color="white"><b>' . $libraryDesc . '</b></font></td>' . "\n";
                        print '</tr>' . "\n";
                        print '<tr align="center" bgcolor="black">' . "\n";
                        print '<td><font color="white"><b>Grade</b></font></td>' . "\n";
                        print '<td><font color="white"><b>Readers</b></font></td>' . "\n";
                        print '</tr>' . "\n";
                    }
                    
                    $gradeTotal = '0';
                    foreach ( $grades as $gradeId=>$gradeDesc ) {
                        if ( is_numeric( $gradeId )) {
                            
                            $sql = "SELECT library.library_id, library.desc, COUNT(*) AS 'count'
                                FROM `library`, `reader`
                                WHERE reader.library_id = library.library_id
                                AND reader.grade_id = $gradeId
                                AND library.library_id = $libraryId
                                LIMIT 1;";
                            $results = mysql_query( $sql, $dbLink );
                            
                            $recs = mysql_fetch_assoc( $results );
                            $gradeTotal += $recs['count'];
                            
                            if ( $format == 'dw' ) {
                                print '| ' . $gradeDesc . '  |  ' . number_format( $recs['count'] ) . ' |' . "\n";
                            }
                            else {
                                print '<tr>' . "\n";
                                print '<td>' . $gradeDesc . '</td>' . "\n";
                                print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                                print '</tr>' . "\n";
                            }
                        }
                    }
                    
                    if ( $format == 'dw' ) {
                        print '^ Total  ^  ' . number_format( $gradeTotal ) . ' ^' . "\n\n";
                    }
                    else {
                        print '<tr>' . "\n";
                        print '<td><b>Total</b></td>' . "\n";
                        print '<td align="right"><b>' . number_format( $gradeTotal ) . '</b></td>' . "\n";
                        print '</tr>' . "\n";
                        print '</table><br>' . "\n";
                    }
                    
                }
            }
            if ( $format == 'dw' ) {
                print '</pre>' . "\n";
            }
        }
        // Tracking by grade disabled, display error message.
        else {
            print '<h2 align="center"><font color="red">Tracking by grade is disabled for this program.</font></h2>' . "\n";
        }
        
    // End function countReadersByGrade
    }
    
    
    function countReadersByLibrary( $progId, $format ) {
        
        $libraries = $this->getLibraries();
        
        $dbLink = $this->dbReportAccess( $progId );
        
        print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
        print '<h2 align="center">Count of Readers by Library</h2>' . "\n";
        print '<h3 align="center"> as of ' . $this->dateOffset( 'Y-m-d g:ia' ) . '</h3>' . "\n";
        
        if ( $format == 'dw' ) {
            print '<pre>' . "\n";
            print '===== Registered readers by library =====' . "\n\n";
            print '^ Branch ^ Readers ^' . "\n";
        }
        else {
            
            print '<table align="center" cellpadding="7" border="4">' . "\n";
            print '<tr align="center" bgcolor="black">' . "\n";
            print '<td><font color="white"><b>Library</b></font></td>' . "\n";
            print '<td><font color="white"><b>Readers</b></font></td>' . "\n";
            print '</tr>' . "\n";
        }
        
        foreach ( $libraries as $id=>$desc ) {
            if ( is_numeric( $id )) {
                
                $sql = "SELECT COUNT(*) AS 'count' FROM `reader` WHERE `library_id` = $id LIMIT 1;";
                $results = mysql_query( $sql, $dbLink );
               
                $recs = mysql_fetch_assoc( $results );
               
                if ( $format == 'dw' ) {
                    print '| ' . $desc . '  |  ' . number_format( $recs['count'] ) . ' |' . "\n";
                }
                else {
                    print '<tr>' . "\n";
                    print '<td>' . $desc . '</td>' . "\n";
                    print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                    print '</tr>' . "\n";
               }
            }
        }
        
        if ( $format == 'dw' ) {
            print '^ Total  ^  ' . $this->countReaders( $progId ) . ' ^' . "\n";
            print '</pre>' . "\n";
        }
        else {
            print '<tr>' . "\n";
            print '<td><b>Total</b></td>' . "\n";
            print '<td align="right"><b>' . $this->countReaders( $progId ) . '</b></td>' . "\n";
            print '</tr>' . "\n";
            print '</table>' . "\n";
        }
        
    // End function countReadersByLibrary
    }
    
    
    function countReadersBySchool( $progId, $format ) {
        
        $libraries = $this->getLibraries();
        $schools = $this->getSchools();
        
        
        $dbLink = $this->dbReportAccess( $progId );
        
        // Tracking by school enabled, so show report.
        if ( $this->configProg['useSchool'] == '1' ) {
            print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
            print '<h2 align="center">Count of Readers by School</h2>' . "\n";
            print '<h3 align="center"> as of ' . $this->dateOffset( 'Y-m-d g:ia' ) . '</h3>' . "\n";
            
            if ( $format == 'dw' ) {
                print '<pre>' . "\n";
                print '===== Registered readers by school =====' . "\n\n";
                print '==== All Libraries ====' . "\n\n";
                print '^  School Name  ^  Readers  ^' . "\n";
            }
            else {
                print '<table align="center" cellpadding="7" border="4">' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td colspan="2"><font color="white"><b>All Libraries</b></font></td>' . "\n";
                print '</tr>' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td><font color="white"><b>School Name</b></font></td>' . "\n";
                print '<td><font color="white"><b>Readers</b></font></td>' . "\n";
                print '</tr>' . "\n";
            }
            
            // All libraries.
            $schoolTotal = '0';
            foreach ( $schools as $schoolId=>$schoolDesc ) {
                if ( is_numeric( $schoolId )) {
                    
                    $sql = "SELECT COUNT(*) AS 'count'
                        FROM `reader`
                        WHERE reader.school_id = $schoolId
                        LIMIT 1;";
                    $results = mysql_query( $sql, $dbLink );
                    
                    $recs = mysql_fetch_assoc( $results );
                    $schoolTotal += $recs['count'];
                    
                    if ( $format == 'dw' ) {
                        print '| ' . $schoolDesc . '  |  ' . number_format( $recs['count'] ) . ' |' . "\n";
                    }
                    else {
                        print '<tr>' . "\n";
                        print '<td>' . $schoolDesc . '</td>' . "\n";
                        print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                        print '</tr>' . "\n";
                    }
                }
            }
            
            if ( $format == 'dw' ) {
                print '^ Total  ^  ' . number_format( $schoolTotal ) . ' ^' . "\n\n";
            }
            else {
                print '<tr>' . "\n";
                print '<td><b>Total</b></td>' . "\n";
                print '<td align="right"><b>' . number_format( $schoolTotal ) . '</b></td>' . "\n";
                print '</tr>' . "\n";
                print '</table><br>' . "\n";
            }
            
            // Sub-total by library.
            foreach ( $libraries as $libraryId=>$libraryDesc ) {
                if ( is_numeric( $libraryId )) {
                    
                    if ( $format == 'dw' ) {
                        print '==== ' . $libraryDesc . ' ====' . "\n\n";
                        print '^  School Name</b>  ^  Readers  ^' . "\n";
                    }
                    else {
                        print '<table align="center" cellpadding="7" border="4">' . "\n";
                        print '<tr align="center" bgcolor="black">' . "\n";
                        print '<td colspan="2"><font color="white"><b>' . $libraryDesc . '</b></font></td>' . "\n";
                        print '</tr>' . "\n";
                        print '<tr align="center" bgcolor="black">' . "\n";
                        print '<td><font color="white"><b>School Name</b></font></td>' . "\n";
                        print '<td><font color="white"><b>Readers</b></font></td>' . "\n";
                        print '</tr>' . "\n";
                    }
                    
                    $schoolTotal = '0';
                    foreach ( $schools as $schoolId=>$schoolDesc ) {
                        if ( is_numeric( $schoolId )) {
                            
                            $sql = "SELECT library.library_id, library.desc, COUNT(*) AS 'count'
                                FROM `library`, `reader`
                                WHERE reader.library_id = library.library_id
                                AND reader.school_id = $schoolId
                                AND library.library_id = $libraryId
                                LIMIT 1;";
                            $results = mysql_query( $sql, $dbLink );
                            
                            $recs = mysql_fetch_assoc( $results );
                            $schoolTotal += $recs['count'];
                            
                            if ( $format == 'dw' ) {
                                print '| ' . $schoolDesc . '  |  ' . number_format( $recs['count'] ) . ' |' . "\n";
                            }
                            else {
                                print '<tr>' . "\n";
                                print '<td>' . $schoolDesc . '</td>' . "\n";
                                print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                                print '</tr>' . "\n";
                            }
                        }
                    }
                    
                    if ( $format == 'dw' ) {
                        print '^ Total  ^  ' . number_format( $schoolTotal ) . ' ^' . "\n\n";
                    }
                    else {
                        print '<tr>' . "\n";
                        print '<td><b>Total</b></td>' . "\n";
                        print '<td align="right"><b>' . number_format( $schoolTotal ) . '</b></td>' . "\n";
                        print '</tr>' . "\n";
                        print '</table><br>' . "\n";
                    }
                    
                }
            }
            if ( $format == 'dw' ) {
                print '</pre>' . "\n";
            }
        }
        // Tracking by school disabled, display error message.
        else {
            print '<h2 align="center"><font color="red">Tracking by school is disabled for this program.</font></h2>' . "\n";
        }
        
    // End function countReadersBySchool
    }
    
    function countReadersByZipcode( $progId, $format ) {
        
        $libraries = $this->getLibraries();
        $zipcodes = $this->getZipcodes();
        
        $dbLink = $this->dbReportAccess( $progId );
        
        // Tracking by zipcode enabled, so show report.
        if ( $this->configProg['useZipcode'] == '1' ) {
            print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
            print '<h2 align="center">Count of Readers by Zipcode</h2>' . "\n";
            print '<h3 align="center"> as of ' . $this->dateOffset( 'Y-m-d g:ia' ) . '</h3>' . "\n";
            
            if ( $format == 'dw' ) {
                print '<pre>' . "\n";
                print '===== Registered readers by zipcode =====' . "\n\n";
                print '==== All Libraries ====' . "\n\n";
                print '^  Zipcode  ^  Readers  ^' . "\n";
            }
            else {
                print '<table align="center" cellpadding="7" border="4">' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td colspan="2"><font color="white"><b>All Libraries</b></font></td>' . "\n";
                print '</tr>' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td><font color="white"><b>Zipcode</b></font></td>' . "\n";
                print '<td><font color="white"><b>Readers</b></font></td>' . "\n";
                print '</tr>' . "\n";
            }
            
            // All libraries.
            $zipcodeTotal = '0';
            foreach ( $zipcodes as $zipcodeId=>$zipcodeDesc ) {
                if ( is_numeric( $zipcodeId )) {
                    
                    $sql = "SELECT COUNT(*) AS 'count'
                        FROM `reader`
                        WHERE reader.zipcode_id = $zipcodeId
                        LIMIT 1;";
                    $results = mysql_query( $sql, $dbLink );
                    
                    $recs = mysql_fetch_assoc( $results );
                    $zipcodeTotal += $recs['count'];
                    
                    if ( $format == 'dw' ) {
                        print '| ' . $zipcodeDesc . '  |  ' . number_format( $recs['count'] ) . ' |' . "\n";
                    }
                    else {
                        print '<tr>' . "\n";
                        print '<td>' . $zipcodeDesc . '</td>' . "\n";
                        print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                        print '</tr>' . "\n";
                    }
                }
            }
            
            if ( $format == 'dw' ) {
                print '^ Total  ^  ' . number_format( $zipcodeTotal ) . ' ^' . "\n\n";
            }
            else {
                print '<tr>' . "\n";
                print '<td><b>Total</b></td>' . "\n";
                print '<td align="right"><b>' . number_format( $zipcodeTotal ) . '</b></td>' . "\n";
                print '</tr>' . "\n";
                print '</table><br>' . "\n";
            }
            
            // Sub-total by library.
            foreach ( $libraries as $libraryId=>$libraryDesc ) {
                if ( is_numeric( $libraryId )) {
                    
                    if ( $format == 'dw' ) {
                        print '==== ' . $libraryDesc . ' ====' . "\n\n";
                        print '^  Zipcode  ^  Readers  ^' . "\n";
                    }
                    else {
                        print '<table align="center" cellpadding="7" border="4">' . "\n";
                        print '<tr align="center" bgcolor="black">' . "\n";
                        print '<td colspan="2"><font color="white"><b>' . $libraryDesc . '</b></font></td>' . "\n";
                        print '</tr>' . "\n";
                        print '<tr align="center" bgcolor="black">' . "\n";
                        print '<td><font color="white"><b>Zipcode</b></font></td>' . "\n";
                        print '<td><font color="white"><b>Readers</b></font></td>' . "\n";
                        print '</tr>' . "\n";
                    }
                    
                    $zipcodeTotal = '0';
                    foreach ( $zipcodes as $zipcodeId=>$zipcodeDesc ) {
                        if ( is_numeric( $zipcodeId )) {
                            
                            $sql = "SELECT library.library_id, library.desc, COUNT(*) AS 'count'
                                FROM `library`, `reader`
                                WHERE reader.library_id = library.library_id
                                AND reader.zipcode_id = $zipcodeId
                                AND library.library_id = $libraryId
                                LIMIT 1;";
                            $results = mysql_query( $sql, $dbLink );
                            
                            $recs = mysql_fetch_assoc( $results );
                            $zipcodeTotal += $recs['count'];
                            
                            if ( $format == 'dw' ) {
                                print '| ' . $zipcodeDesc . '  |  ' . number_format( $recs['count'] ) . ' |' . "\n";
                            }
                            else {
                                print '<tr>' . "\n";
                                print '<td>' . $zipcodeDesc . '</td>' . "\n";
                                print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                                print '</tr>' . "\n";
                            }
                        }
                    }
                    
                    if ( $format == 'dw' ) {
                        print '^ Total  ^  ' . number_format( $zipcodeTotal ) . ' ^' . "\n\n";
                    }
                    else {
                        print '<tr>' . "\n";
                        print '<td><b>Total</b></td>' . "\n";
                        print '<td align="right"><b>' . number_format( $zipcodeTotal ) . '</b></td>' . "\n";
                        print '</tr>' . "\n";
                        print '</table><br>' . "\n";
                    }
                    
                }
            }
            if ( $format == 'dw' ) {
                print '</pre>' . "\n";
            }
        }
        // Tracking by zipcode disabled, display error message.
        else {
            print '<h2 align="center"><font color="red">Tracking by zipcode is disabled for this program.</font></h2>' . "\n";
        }
        
    // End function countReadersByZipcode
    }
    
    
    protected function countRecords( $progId ) {
        
        // FIXME: This method should return 0 if DB credentials are invalid.
        
        $dbLink = $this->dbReportAccess( $progId );
        
        $sql = "SELECT COUNT(*) AS 'count' FROM `record` LIMIT 1;";
        $results = mysql_query( $sql, $dbLink );
        
        $count = mysql_fetch_assoc( $results );
        return( number_format( $count['count'] ));
        
    // End function countRecords
    }
    
    
    function countRecordsByAge( $progId, $format ) {
        
        $libraries = $this->getLibraries();
        $levels = $this->getLevels();
        $ages = $this->getAges();
        $colSpan = count( $levels ) + 2;
        
        $dbLink = $this->dbReportAccess( $progId );
        
        // Tracking by age enabled, so show report.
        if ( $this->configProg['useAge'] == '1' ) {
            print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
            print '<h2 align="center">Count of completed levels by age</h2>' . "\n";
            print '<h3 align="center"> as of ' . $this->dateOffset( 'Y-m-d g:ia' ) . '</h3>' . "\n";
            
            if ( $format == 'dw' ) {
                print '<pre>' . "\n";
                print '===== Completed levels by age =====' . "\n\n";
                print '==== All Libraries ====' . "\n\n";
                print '^  ';
                foreach ( $levels as $levelId=>$levelDesc ) {
                    print '^  ' . $levelDesc . '  ';
                }
                print '^  Total  ';
                print '^' . "\n";
            }
            else {
                print '<table align="center" cellpadding="7" border="4">' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td colspan="' . $colSpan . '"><font color="white"><b>All Libraries</b></font></td>' . "\n";
                print '</tr>' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td><font color="white"><b></b></font></td>' . "\n";
                foreach ( $levels as $levelId=>$levelDesc ) {
                    print '<td><font color="white">' . $levelDesc . '</font></td>' . "\n";
                }
                print '<td><font color="white"><b>Total</b></font></td>' . "\n";
                print '</tr>' . "\n";   
            }
            
            // All libraries.
            foreach ( $ages as $ageId=>$ageDesc ) {
                if ( is_numeric( $ageId )) {
                    
                    if ( $format == 'dw' ) {
                        print '| '. $ageDesc . '  ';
                    }
                    else {
                        print '<tr>' . "\n";
                        print '<td>' . $ageDesc . '</td>' . "\n";
                    }
                    
                    $rowTotal = '0';
                    foreach ($levels as $levelId=>$levelDesc ) {
                        if ( is_numeric( $levelId )) {
                            
                            $sql = "SELECT COUNT(*) AS 'count'
                                FROM `record`, `reader`
                                WHERE record.reader_id = reader.reader_id
                                AND reader.age_id = $ageId
                                AND record.level_id = $levelId
                                LIMIT 1;";
                            $results = mysql_query( $sql, $dbLink );
                            
                            $recs = mysql_fetch_assoc( $results );
                            $rowTotal += $recs['count'];
                         
                            if ( $format == 'dw' ) {
                                print '|  ' . number_format( $recs['count'] ) . ' ';
                            }
                            else {
                                print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                            }
                            
                        }
                    }
                    
                    if ( $format == 'dw' ) {
                        print '^  ' . number_format( $rowTotal ) . ' ^' . "\n";
                    }
                    else {
                        print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                        print '</tr>' . "\n";
                    }
                    
                }
            }
            
            // Grand total row
            if ( $format == 'dw' ) {
                print '^ Total  ';
            }
            else {
                print '<tr>' . "\n";
                print '<td><b>Total</b></td>' . "\n";
            }
            
            $rowTotal = '0';
            foreach ($levels as $levelId=>$levelDesc ) {
                if ( is_numeric( $levelId )) {
                    
                    $sql = "SELECT COUNT(*) AS 'count'
                        FROM `record`, `reader`
                        WHERE record.reader_id = reader.reader_id
                        AND record.level_id = $levelId
                        LIMIT 1;";
                    $results = mysql_query( $sql, $dbLink );
                    
                    $recs = mysql_fetch_assoc( $results );
                    $rowTotal += $recs['count'];
                 
                    if ( $format == 'dw' ) {
                        print '^  ' . number_format( $recs['count'] ) . ' ';
                    }
                    else {
                        print '<td align="right"><b>' . number_format( $recs['count'] ) . '</b></td>' . "\n";
                    }
                    
                }
            }
            
            if ( $format == 'dw' ) {
                print '^  ' . number_format( $rowTotal ) . ' ^' . "\n\n";
            }
            else {
                print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                print '</tr>' . "\n";
                print '</table><br>' . "\n";
            }
            
            // If tracking by library is enabled, sub-total by library.
            if ( $this->configProg['useLibrary'] == '1' ) {
                foreach ( $libraries as $libraryId=>$libraryDesc ) {
                    if ( is_numeric( $libraryId )) {
                        
                        if ( $format == 'dw' ) {
                            print '==== ' . $libraryDesc . ' ====' . "\n\n";
                            print '^  ';
                            foreach ( $levels as $levelId=>$levelDesc ) {
                                print '^  ' . $levelDesc . '  ';
                            }
                            print '^  Total  ';
                            print '^' . "\n";
                        }
                        else {
                            print '<table align="center" cellpadding="7" border="4">' . "\n";
                            print '<tr align="center" bgcolor="black">' . "\n";
                            print '<td colspan="' . $colSpan . '"><font color="white"><b>' . $libraryDesc . '</b></font></td>' . "\n";
                            print '</tr>' . "\n";
                            
                            print '<tr align="center" bgcolor="black">' . "\n";
                            print '<td><font color="white"><b></b></font></td>' . "\n";
                            foreach ( $levels as $levelId=>$levelDesc ) {
                                print '<td><font color="white">' . $levelDesc . '</font></td>' . "\n";
                            }
                            print '<td><font color="white"><b>Total</b></font></td>' . "\n";
                            print '</tr>' . "\n";
                        }
                        
                        foreach ( $ages as $ageId=>$ageDesc ) {
                            if ( is_numeric( $ageId )) {
                                
                                if ( $format == 'dw' ) {
                                    print '| ' . $ageDesc . '  ';
                                }
                                else {
                                    print '<tr>' . "\n";
                                    print '<td>' . $ageDesc . '</td>' . "\n";
                                }
                                
                                $rowTotal = '0';
                                foreach ($levels as $levelId=>$levelDesc ) {
                                    if ( is_numeric( $levelId )) {
                                        
                                        $sql = "SELECT COUNT(*) AS 'count'
                                            FROM `record`, `reader`
                                            WHERE record.reader_id = reader.reader_id
                                            AND reader.age_id = $ageId
                                            AND reader.library_id = $libraryId
                                            AND record.level_id = $levelId
                                            LIMIT 1;";
                                        $results = mysql_query( $sql, $dbLink );
                                        
                                        $recs = mysql_fetch_assoc( $results );
                                        $rowTotal += $recs['count'];
                                     
                                        if ( $format == 'dw' ) {
                                            print '|  ' . number_format( $recs['count'] ) . ' ';
                                        }
                                        else {
                                            print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                                        }
                                    }
                                }
                                
                                if ( $format == 'dw' ) {
                                    print '^  ' . number_format( $rowTotal ) . ' ^' . "\n";
                                }
                                else {
                                    print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                                    print '</tr>' . "\n";
                                }
                                
                            }
                        }
                        
                        // Grand total row
                        if ( $format == 'dw' ) {
                            print '^ Total  ';
                        }
                        else {
                            print '<tr>' . "\n";
                            print '<td><b>Total</b></td>' . "\n";
                        }
                        
                        $rowTotal = '0';
                        foreach ($levels as $levelId=>$levelDesc ) {
                            if ( is_numeric( $levelId )) {
                                
                                $sql = "SELECT COUNT(*) AS 'count'
                                    FROM `record`, `reader`
                                    WHERE record.reader_id = reader.reader_id
                                    AND reader.library_id = $libraryId
                                    AND record.level_id = $levelId
                                    LIMIT 1;";
                                $results = mysql_query( $sql, $dbLink );
                                
                                $recs = mysql_fetch_assoc( $results );
                                $rowTotal += $recs['count'];
                             
                                if ( $format == 'dw' ) {
                                    print '^  ' . number_format( $recs['count'] ) . ' ';
                                }
                                else {
                                    print '<td align="right"><b>' . number_format( $recs['count'] ) . '</b></td>' . "\n";
                                }
                            }
                        }
                        
                        if ( $format == 'dw' ) {
                            print '^  ' . number_format( $rowTotal ) . ' ^' . "\n\n";
                        }
                        else {
                            print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                            print '</tr>' . "\n";
                            print '</table><br>' . "\n";
                        }
                    }
                }
            }
            if ( $format == 'dw' ) {
                print '</pre>' . "\n";
            }
        }
        // Tracking by age disabled, display error message.
        else {
            print '<h2 align="center"><font color="red">Tracking by age is disabled for this program.</font></h2>' . "\n";
        }
        
    // End function countRecordsByAge
    }
    
    
    function countRecordsByCity( $progId, $format ) {
        
        $libraries = $this->getLibraries();
        $levels = $this->getLevels();
        $cities = $this->getCities();
        $colSpan = count( $levels ) + 2;
        
        $dbLink = $this->dbReportAccess( $progId );
        
        // Tracking by city enabled, so show report.
        if ( $this->configProg['useCity'] == '1' ) {
            print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
            print '<h2 align="center">Count of completed levels by city</h2>' . "\n";
            print '<h3 align="center"> as of ' . $this->dateOffset( 'Y-m-d g:ia' ) . '</h3>' . "\n";
            
            if ( $format == 'dw' ) {
                print '<pre>' . "\n";
                print '===== Completed levels by city =====' . "\n\n";
                print '==== All Libraries ====' . "\n\n";
                print '^  ';
                foreach ( $levels as $levelId=>$levelDesc ) {
                    print '^  ' . $levelDesc . '  ';
                }
                print '^  Total  ^' . "\n";
            }
            else {
                print '<table align="center" cellpadding="7" border="4">' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td colspan="' . $colSpan . '"><font color="white"><b>All Libraries</b></font></td>' . "\n";
                print '</tr>' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td><font color="white"><b></b></font></td>' . "\n";
                foreach ( $levels as $levelId=>$levelDesc ) {
                    print '<td><font color="white">' . $levelDesc . '</font></td>' . "\n";
                }
                print '<td><font color="white"><b>Total</b></font></td>' . "\n";
                print '</tr>' . "\n";
            }
            
            // All libraries.
            foreach ( $cities as $cityId=>$cityDesc ) {
                if ( is_numeric( $cityId )) {
                    
                    if ( $format == 'dw' ) {
                        print '| ' . $cityDesc . '  ';
                    }
                    else {
                        print '<tr>' . "\n";
                        print '<td>' . $cityDesc . '</td>' . "\n";
                    }
                    
                    $rowTotal = '0';
                    foreach ($levels as $levelId=>$levelDesc ) {
                        if ( is_numeric( $levelId )) {
                            
                            $sql = "SELECT COUNT(*) AS 'count'
                                FROM `record`, `reader`
                                WHERE record.reader_id = reader.reader_id
                                AND reader.city_id = $cityId
                                AND record.level_id = $levelId
                                LIMIT 1;";
                            $results = mysql_query( $sql, $dbLink );
                            
                            $recs = mysql_fetch_assoc( $results );
                            $rowTotal += $recs['count'];
                         
                            if ( $format == 'dw' ) {
                                print '|  ' . number_format( $recs['count'] ) . ' ';
                            }
                            else {
                                print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                            }
                        }
                    }
                    
                    if ( $format == 'dw' ) {
                        print '^  ' . number_format( $rowTotal ) . ' ^' . "\n";
                    }
                    else {
                        print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                        print '</tr>' . "\n";
                    }
                }
            }
            
            // Grand total row
            if ( $format == 'dw' ) {
                print '^ Total  ';
            }
            else {
                print '<tr>' . "\n";
                print '<td><b>Total</b></td>' . "\n";
            }
            
            $rowTotal = '0';
            foreach ($levels as $levelId=>$levelDesc ) {
                if ( is_numeric( $levelId )) {
                    
                    $sql = "SELECT COUNT(*) AS 'count'
                        FROM `record`, `reader`
                        WHERE record.reader_id = reader.reader_id
                        AND record.level_id = $levelId
                        LIMIT 1;";
                    $results = mysql_query( $sql, $dbLink );
                    
                    $recs = mysql_fetch_assoc( $results );
                    $rowTotal += $recs['count'];
                 
                    if ( $format == 'dw' ) {
                        print '^  ' . number_format( $recs['count'] ) . ' ';
                    }
                    else {
                        print '<td align="right"><b>' . number_format( $recs['count'] ) . '</b></td>' . "\n";
                    }
                }
            }
            
            if ( $format == 'dw' ) {
                print '^  ' . number_format( $rowTotal ) . ' ^' . "\n\n";
            }
            else {
                print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                print '</tr>' . "\n";
                print '</table><br>' . "\n";
            }
            
            // If tracking by library is enabled, sub-total by library.
            if ( $this->configProg['useLibrary'] == '1' ) {
                foreach ( $libraries as $libraryId=>$libraryDesc ) {
                    if ( is_numeric( $libraryId )) {
                        
                        if ( $format == 'dw' ) {
                            print '==== ' . $libraryDesc . ' ====' . "\n\n";
                            print '^  ';
                            foreach ( $levels as $levelId=>$levelDesc ) {
                                print '^  ' . $levelDesc . '  ';
                            }
                            print '^  Total  ^' . "\n";
                        }
                        else {
                            print '<table align="center" cellpadding="7" border="4">' . "\n";
                            print '<tr align="center" bgcolor="black">' . "\n";
                            print '<td colspan="' . $colSpan . '"><font color="white"><b>' . $libraryDesc . '</b></font></td>' . "\n";
                            print '</tr>' . "\n";
                            
                            print '<tr align="center" bgcolor="black">' . "\n";
                            print '<td><font color="white"><b></b></font></td>' . "\n";
                            foreach ( $levels as $levelId=>$levelDesc ) {
                                print '<td><font color="white">' . $levelDesc . '</font></td>' . "\n";
                            }
                            print '<td><font color="white"><b>Total</b></font></td>' . "\n";
                            print '</tr>' . "\n";
                        }
                        
                        foreach ( $cities as $cityId=>$cityDesc ) {
                            if ( is_numeric( $cityId )) {
                                
                                if ( $format == 'dw' ) {
                                    print '| ' . $cityDesc . '  ';
                                }
                                else {
                                    print '<tr>' . "\n";
                                    print '<td>' . $cityDesc . '</td>';
                                }
                                
                                $rowTotal = '0';
                                foreach ($levels as $levelId=>$levelDesc ) {
                                    if ( is_numeric( $levelId )) {
                                        
                                        $sql = "SELECT COUNT(*) AS 'count'
                                            FROM `record`, `reader`
                                            WHERE record.reader_id = reader.reader_id
                                            AND reader.city_id = $cityId
                                            AND reader.library_id = $libraryId
                                            AND record.level_id = $levelId
                                            LIMIT 1;";
                                        $results = mysql_query( $sql, $dbLink );
                                        
                                        $recs = mysql_fetch_assoc( $results );
                                        $rowTotal += $recs['count'];
                                     
                                        if ( $format == 'dw' ) {
                                            print '|  ' . number_format( $recs['count'] ) . ' ';
                                        }
                                        else {
                                            print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                                        }
                                        
                                    }
                                }
                                
                                if ( $format == 'dw' ) {
                                    print '^  ' . number_format( $rowTotal ) . ' ^' . "\n";
                                }
                                else {
                                print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                                print '</tr>' . "\n";
                                }
                            }
                        }
                        
                        // Grand total row
                        if ( $format == 'dw' ) {
                            print '^ Total  ';
                        }
                        else {
                            print '<tr>' . "\n";
                            print '<td><b>Total</b></td>' . "\n";
                        }
                        
                        $rowTotal = '0';
                        foreach ($levels as $levelId=>$levelDesc ) {
                            if ( is_numeric( $levelId )) {
                                
                                $sql = "SELECT COUNT(*) AS 'count'
                                    FROM `record`, `reader`
                                    WHERE record.reader_id = reader.reader_id
                                    AND reader.library_id = $libraryId
                                    AND record.level_id = $levelId
                                    LIMIT 1;";
                                $results = mysql_query( $sql, $dbLink );
                                
                                $recs = mysql_fetch_assoc( $results );
                                $rowTotal += $recs['count'];
                             
                                if ( $format == 'dw' ) {
                                    print '^  ' . number_format( $recs['count'] ) . ' ';
                                }
                                else {
                                    print '<td align="right"><b>' . number_format( $recs['count'] ) . '</b></td>' . "\n";
                                }
                            }
                        }
                        
                        if ( $format == 'dw' ) {
                            print '^  ' . number_format( $rowTotal ) . ' ^' . "\n\n";
                        }
                        else {
                            print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                            print '</tr>' . "\n";
                            print '</table><br>' . "\n";
                        }
                    }
                }
            }
            if ( $format == 'dw' ) {
                print '</pre>' . "\n";
            }
        }
        // Tracking by city disabled, display error message.
        else {
            print '<h2 align="center"><font color="red">Tracking by city is disabled for this program.</font></h2>' . "\n";
        }
        
    // End function countRecordsByCity
    }
    
    
    function countRecordsByGrade( $progId, $format ) {
        
        $libraries = $this->getLibraries();
        $levels = $this->getLevels();
        $grades = $this->getGrades();
        $colSpan = count( $levels ) + 2;
        
        $dbLink = $this->dbReportAccess( $progId );
        
        // Tracking by grade enabled, so show report.
        if ( $this->configProg['useGrade'] == '1' ) {
            print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
            print '<h2 align="center">Count of completed levels by grade</h2>' . "\n";
            print '<h3 align="center"> as of ' . $this->dateOffset( 'Y-m-d g:ia' ) . '</h3>' . "\n";
            
            if ( $format == 'dw' ) {
                print '<pre>' . "\n";
                print '===== Completed levels by grade =====' . "\n\n";
                print '==== All Libraries ====' . "\n\n";
                print '^  ';
                foreach ( $levels as $levelId=>$levelDesc ) {
                    print '^  ' . $levelDesc . '  ';
                }
                print '^  Total  ^' . "\n";
            }
            else {
                print '<table align="center" cellpadding="7" border="4">' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td colspan="' . $colSpan . '"><font color="white"><b>All Libraries</b></font></td>' . "\n";
                print '</tr>' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td><font color="white"><b></b></font></td>' . "\n";
                foreach ( $levels as $levelId=>$levelDesc ) {
                    print '<td><font color="white">' . $levelDesc . '</font></td>' . "\n";
                }
                print '<td><font color="white"><b>Total</b></font></td>' . "\n";
                print '</tr>' . "\n";
            }
            
            // All libraries.
            foreach ( $grades as $gradeId=>$gradeDesc ) {
                if ( is_numeric( $gradeId )) {
                    
                    if ( $format == 'dw' ) {
                        print '| ' . $gradeDesc . '  ';
                    }
                    else {
                        print '<tr>' . "\n";
                        print '<td>' . $gradeDesc . '</td>' . "\n";
                    }
                    
                    $rowTotal = '0';
                    foreach ($levels as $levelId=>$levelDesc ) {
                        if ( is_numeric( $levelId )) {
                            
                            $sql = "SELECT COUNT(*) AS 'count'
                                FROM `record`, `reader`
                                WHERE record.reader_id = reader.reader_id
                                AND reader.grade_id = $gradeId
                                AND record.level_id = $levelId
                                LIMIT 1;";
                            $results = mysql_query( $sql, $dbLink );
                            
                            $recs = mysql_fetch_assoc( $results );
                            $rowTotal += $recs['count'];
                         
                            if ( $format == 'dw' ) {
                                print '|  ' . number_format( $recs['count'] ) . ' ';
                            }
                            else {
                                print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                            }
                        }
                    }
                    
                    if ( $format == 'dw' ) {
                        print '^  ' . number_format( $rowTotal ) . ' ^' . "\n";
                    }
                    else {
                        print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                        print '</tr>' . "\n";
                    }
                }
            }
            
            // Grand total row
            if ( $format == 'dw' ) {
                print '^ Total  ';
            }
            else {
                print '<tr>' . "\n";
                print '<td><b>Total</b></td>' . "\n";
            }
            
            $rowTotal = '0';
            foreach ($levels as $levelId=>$levelDesc ) {
                if ( is_numeric( $levelId )) {
                    
                    $sql = "SELECT COUNT(*) AS 'count'
                        FROM `record`, `reader`
                        WHERE record.reader_id = reader.reader_id
                        AND record.level_id = $levelId
                        LIMIT 1;";
                    $results = mysql_query( $sql, $dbLink );
                    
                    $recs = mysql_fetch_assoc( $results );
                    $rowTotal += $recs['count'];
                 
                    if ( $format == 'dw' ) {
                        print '^  ' . number_format( $recs['count'] ) . ' ';
                    }
                    else {
                        print '<td align="right"><b>' . number_format( $recs['count'] ) . '</b></td>' . "\n";
                    }
                }
            }
            
            if ( $format == 'dw' ) {
                print '^  ' . number_format( $rowTotal ) . ' ^' . "\n\n";
            }
            else {
                print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                print '</tr>' . "\n";
                print '</table><br>' . "\n";
            }
            
            // If tracking by library is enabled, sub-total by library.
            if ( $this->configProg['useLibrary'] == '1' ) {
                foreach ( $libraries as $libraryId=>$libraryDesc ) {
                    if ( is_numeric( $libraryId )) {
                        
                        if ( $format == 'dw' ) {
                            print '==== ' . $libraryDesc . ' ====' . "\n\n";
                            print '^  ';
                            
                            foreach ( $levels as $levelId=>$levelDesc ) {
                                print '^  ' . $levelDesc . '  ';
                            }
                            print '^  Total  ^' . "\n";
                        }
                        else {
                        print '<table align="center" cellpadding="7" border="4">' . "\n";
                        print '<tr align="center" bgcolor="black">' . "\n";
                        print '<td colspan="' . $colSpan . '"><font color="white"><b>' . $libraryDesc . '</b></font></td>' . "\n";
                        print '</tr>' . "\n";
                        
                        print '<tr align="center" bgcolor="black">' . "\n";
                        print '<td><font color="white"><b></b></font></td>' . "\n";
                        foreach ( $levels as $levelId=>$levelDesc ) {
                            print '<td><font color="white">' . $levelDesc . '</font></td>' . "\n";
                        }
                        print '<td><font color="white"><b>Total</b></font></td>' . "\n";
                        print '</tr>' . "\n";
                        }
                        
                        foreach ( $grades as $gradeId=>$gradeDesc ) {
                            if ( is_numeric( $gradeId )) {
                                
                                if ( $format == 'dw' ) {
                                    print '| ' . $gradeDesc . '  ';
                                }
                                else {
                                    print '<tr>' . "\n";
                                    print '<td>' . $gradeDesc . '</td>' . "\n";
                                }
                                
                                $rowTotal = '0';
                                foreach ($levels as $levelId=>$levelDesc ) {
                                    if ( is_numeric( $levelId )) {
                                        
                                        $sql = "SELECT COUNT(*) AS 'count'
                                            FROM `record`, `reader`
                                            WHERE record.reader_id = reader.reader_id
                                            AND reader.grade_id = $gradeId
                                            AND reader.library_id = $libraryId
                                            AND record.level_id = $levelId
                                            LIMIT 1;";
                                        $results = mysql_query( $sql, $dbLink );
                                        
                                        $recs = mysql_fetch_assoc( $results );
                                        $rowTotal += $recs['count'];
                                     
                                        if ( $format == 'dw' ) {
                                            print '|  ' . number_format( $recs['count'] ) . ' ';
                                        }
                                        else {
                                            print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                                        }
                                    }
                                }
                                
                                if ( $format == 'dw' ) {
                                    print '^  ' . number_format( $rowTotal ) . ' ^' . "\n";
                                }
                                else {
                                    print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                                    print '</tr>' . "\n";
                                }
                            }
                        }
                        
                        // Grand total row
                        if ( $format == 'dw' ) {
                            print '^ Total  ';
                        }
                        else {
                            print '<tr>' . "\n";
                            print '<td><b>Total</b></td>' . "\n";
                        }
                        
                        $rowTotal = '0';
                        foreach ($levels as $levelId=>$levelDesc ) {
                            if ( is_numeric( $levelId )) {
                                
                                $sql = "SELECT COUNT(*) AS 'count'
                                    FROM `record`, `reader`
                                    WHERE record.reader_id = reader.reader_id
                                    AND reader.library_id = $libraryId
                                    AND record.level_id = $levelId
                                    LIMIT 1;";
                                $results = mysql_query( $sql, $dbLink );
                                
                                $recs = mysql_fetch_assoc( $results );
                                $rowTotal += $recs['count'];
                             
                                if ( $format == 'dw' ) {
                                    print '^  ' . number_format( $recs['count'] ) . ' ';
                                }
                                else {
                                    print '<td align="right"><b>' . number_format( $recs['count'] ) . '</b></td>' . "\n";
                                }
                            }
                        }
                        
                        if ( $format == 'dw'  ) {
                            print '^  ' . number_format( $rowTotal ) . ' ^' . "\n\n";
                        }
                        else {
                            print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                            print '</tr>' . "\n";
                            print '</table><br>' . "\n";
                        }
                    }
                }
            }
            if ( $format == 'dw' ) {
                print '</pre>' . "\n";
            }
        }
        // Tracking by grade disabled, display error message.
        else {
            print '<h2 align="center"><font color="red">Tracking by grade is disabled for this program.</font></h2>' . "\n";
        }
        
    // End function countRecordsByGrade
    }
    
    
    function countRecordsByLevelAndLibrary( $progId, $format ) {
        
        $libraries = $this->getLibraries();
        $levels = $this->getLevels();
        
        $dbLink = $this->dbReportAccess( $progId );
        
        print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
        print '<h2 align="center">Count of completed levels by level and Library</h2>' . "\n";
        print '<h3 align="center"> as of ' . $this->dateOffset( 'Y-m-d g:ia' ) . '</h3>' . "\n";
        
        if ( $format == 'dw' ) {
            print '<pre> ' . "\n";
            print '===== Completed levels by level =====' . "\n\n";
            print '==== All Libraries ====' . "\n\n";
            print '^  Level Name  ^  Completed  ^' . "\n";
        }
        else {
        print '<table align="center" cellpadding="7" border="4">' . "\n";
        print '<tr align="center" bgcolor="black">' . "\n";
        print '<td colspan="2"><font color="white"><b>All Libraries</b></font></td>' . "\n";
        print '</tr>' . "\n";
        print '<tr align="center" bgcolor="black">' . "\n";
        print '<td><font color="white"><b>Level Name</b></font></td>' . "\n";
        print '<td><font color="white"><b>Completed</b></font></td>' . "\n";
        print '</tr>' . "\n";
        }
        
        // All libraries.
        $levelTotal = '0';
        foreach ( $levels as $levelId=>$levelDesc ) {
            if ( is_numeric( $levelId )) {
                
                $sql = "SELECT COUNT(*) AS 'count'
                    FROM `record`, `reader`
                    WHERE record.reader_id = reader.reader_id
                    AND record.level_id = $levelId
                    LIMIT 1;";
                $results = mysql_query( $sql, $dbLink );
             
                $recs = mysql_fetch_assoc( $results );
                $levelTotal += $recs['count'];
                
                if ( $format == 'dw' ) {
                    print '| ' . $levelDesc . '  |  ' . number_format( $recs['count'] ) . ' |' . "\n";
                }
                else {
                    print '<tr>' . "\n";
                    print '<td>' . $levelDesc . '</td>' . "\n";
                    print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                    print '</tr>' . "\n";
                }
            }
        }
        
        if ( $format == 'dw' ) {
            print '^ Total  ^  ' . number_format( $levelTotal ) . ' ^' . "\n\n";
        }
        else {
            print '<tr>' . "\n";
            print '<td><b>Total</b></td>' . "\n";
            print '<td align="right"><b>' . number_format( $levelTotal ) . '</b></td>' . "\n";
            print '</tr>' . "\n";
            print '</table><br>' . "\n";
        }
        
        // If tracking by library is enabled, sub-total by library.
        if ( $this->configProg['useLibrary'] == '1' ) {
            foreach ( $libraries as $libraryId=>$libraryDesc ) {
                if ( is_numeric( $libraryId )) {
                    
                    if ( $format == 'dw' ) {
                        print '==== ' . $libraryDesc . ' ====' . "\n\n";
                        print '^  Level Name  ^  Completed  ^' . "\n";
                    }
                    else {
                        print '<table align="center" cellpadding="7" border="4">' . "\n";
                        print '<tr align="center" bgcolor="black">' . "\n";
                        print '<td colspan="2"><font color="white"><b>' . $libraryDesc . '</b></font></td>' . "\n";
                        print '</tr>' . "\n";
                        print '<tr align="center" bgcolor="black">' . "\n";
                        print '<td><font color="white"><b>Level Name</b></font></td>' . "\n";
                        print '<td><font color="white"><b>Completed</b></font></td>' . "\n";
                        print '</tr>' . "\n";
                    }
                    
                    $levelTotal = '0';
                    foreach ( $levels as $levelId=>$levelDesc ) {
                        if ( is_numeric( $levelId )) {
                            
                            $sql = "SELECT library.library_id, library.desc, COUNT(*) AS 'count'
                                FROM `library`, `record`, `reader`
                                WHERE reader.library_id = library.library_id
                                AND record.reader_id = reader.reader_id
                                AND record.level_id = $levelId
                                AND library.library_id = $libraryId
                                LIMIT 1;";
                            $results = mysql_query( $sql, $dbLink );
                            
                            $recs = mysql_fetch_assoc( $results );
                            $levelTotal += $recs['count'];
                           
                            if ( $format == 'dw' ) {
                                print '| ' . $levelDesc . '  |  ' . number_format( $recs['count'] ) . ' |' . "\n";
                            }
                            else {
                                print '<tr>' . "\n";
                                print '<td>' . $levelDesc . '</td>' . "\n";
                                print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                                print '</tr>' . "\n";
                            }
                        }
                    }
                    
                    if ( $format == 'dw' ) {
                        print '^ Total  ^  ' . number_format( $levelTotal ) . ' ^' . "\n\n";
                    }
                    else {
                        print '<tr>' . "\n";
                        print '<td><b>Total</b></td>' . "\n";
                        print '<td align="right"><b>' . number_format( $levelTotal ) . '</b></td>' . "\n";
                        print '</tr>' . "\n";
                        print '</table><br>' . "\n";
                    }
                }
            }
        }
        if ( $format == 'dw' ) {
            print '</pre>' . "\n";
        }
        
    // End function countRecordsByLevelAndLibrary
    }
    
    
    function countRecordsByLibrary( $progId, $format ) {
        
        $libraries = $this->getLibraries();
        
        $dbLink = $this->dbReportAccess( $progId );
        
        print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
        print '<h2 align="center">Count of completed levels by Library</h2>' . "\n";
        print '<h3 align="center"> as of ' . $this->dateOffset( 'Y-m-d g:ia' ) . '</h3>' . "\n";
        
        if ( $format == 'dw' ) {
            print '<pre>' . "\n";
            print '===== Completed levels by library =====' . "\n\n";
            print '^  Library  ^  Completed Levels  ^' . "\n";
        }
        else {
            print '<table align="center" cellpadding="7" border="4">' . "\n";
            print '<tr align="center" bgcolor="black">' . "\n";
            print '<td><font color="white"><b>Library</b></font></td>' . "\n";
            print '<td><font color="white"><b>Completed Levels</b></font></td>' . "\n";
            print '</tr>' . "\n";
        }
        
        foreach ( $libraries as $id=>$desc ) {
            if ( is_numeric( $id )) {
               
                $sql = "SELECT library.library_id, library.desc, COUNT(*) AS 'count'
                    FROM `library`, `record`, `reader`
                    WHERE reader.library_id = library.library_id
                    AND record.reader_id = reader.reader_id
                    AND library.library_id = $id LIMIT 1;";
                $results = mysql_query( $sql, $dbLink );
                
                $recs = mysql_fetch_assoc( $results );
                
                if ( $format == 'dw' ) {
                    print '| ' . $desc . '  |  ' . number_format( $recs['count'] ) . ' |' . "\n";
                }
                else {
                    print '<tr>' . "\n";
                    print '<td>' . $desc . '</td>' . "\n";
                    print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                    print '</tr>' . "\n";
                }
            }
        }
        
        if ( $format == 'dw' ) {
            print '^ Total  ^  ' . $this->countRecords( $progId ) . ' ^' . "\n";
            print '</pre>' . "\n";
        }
        else {
            print '<tr>' . "\n";
            print '<td><b>Total</b></td>' . "\n";
            print '<td align="right"><b>' . $this->countRecords( $progId ) . '</b></td>' . "\n";
            print '</tr>' . "\n";
            print '</table>' . "\n";
        }
        
    // End function countRecordsByLibrary
    }
    
    
    function countRecordsBySchool( $progId, $format ) {
        
        $libraries = $this->getLibraries();
        $levels = $this->getLevels();
        $schools = $this->getSchools();
        $colSpan = count( $levels ) + 2;
        
        $dbLink = $this->dbReportAccess( $progId );
        
        // Tracking by school enabled, so show report.
        if ( $this->configProg['useSchool'] == '1' ) {
            print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
            print '<h2 align="center">Count of completed levels by school</h2>' . "\n";
            print '<h3 align="center"> as of ' . $this->dateOffset( 'Y-m-d g:ia' ) . '</h3>' . "\n";
            
            if ( $format == 'dw' ) {
                print '<pre>' . "\n";
                print '===== Completed levels by school =====' . "\n\n";
                print '==== All Libraries ====' . "\n\n";
                print '^  ';
                foreach ( $levels as $levelId=>$levelDesc ) {
                    print '^  ' . $levelDesc . '  ';
                }
                print '^  Total  ^' . "\n";
            }
            else {
                print '<table align="center" cellpadding="7" border="4">' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td colspan="' . $colSpan . '"><font color="white"><b>All Libraries</b></font></td>' . "\n";
                print '</tr>' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td><font color="white"><b></b></font></td>' . "\n";
                foreach ( $levels as $levelId=>$levelDesc ) {
                    print '<td><font color="white">' . $levelDesc . '</font></td>' . "\n";
                }
                print '<td><font color="white"><b>Total</b></font></td>' . "\n";
                print '</tr>' . "\n";
            }
            
            // All libraries.
            foreach ( $schools as $schoolId=>$schoolDesc ) {
                if ( is_numeric( $schoolId )) {
                    
                    if ( $format == 'dw' ) {
                        print '| ' . $schoolDesc . '  ';
                    }
                    else {
                        print '<tr>' . "\n";
                        print '<td>' . $schoolDesc . '</td>' . "\n";
                    }
                    
                    $rowTotal = '0';
                    foreach ($levels as $levelId=>$levelDesc ) {
                        if ( is_numeric( $levelId )) {
                            
                            $sql = "SELECT COUNT(*) AS 'count'
                                FROM `record`, `reader`
                                WHERE record.reader_id = reader.reader_id
                                AND reader.school_id = $schoolId
                                AND record.level_id = $levelId
                                LIMIT 1;";
                            $results = mysql_query( $sql, $dbLink );
                            
                            $recs = mysql_fetch_assoc( $results );
                            $rowTotal += $recs['count'];
                         
                            if ( $format == 'dw' ) {
                                print '|  ' . number_format( $recs['count'] ) . ' ';
                            }
                            else {
                                print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                            }
                        }
                    }
                    
                    if ( $format == 'dw' ) {
                        print '^  ' . number_format( $rowTotal ) . ' ^' . "\n";
                    }
                    else {
                        print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                        print '</tr>' . "\n";
                    }
                }
            }
            
            // Grand total row
            if ( $format == 'dw' ) {
                print '^ Total  ';
            }
            else {
                print '<tr>' . "\n";
                print '<td><b>Total</b></td>' . "\n";
            }
            
            $rowTotal = '0';
            foreach ($levels as $levelId=>$levelDesc ) {
                if ( is_numeric( $levelId )) {
                    
                    $sql = "SELECT COUNT(*) AS 'count'
                        FROM `record`, `reader`
                        WHERE record.reader_id = reader.reader_id
                        AND record.level_id = $levelId
                        LIMIT 1;";
                    $results = mysql_query( $sql, $dbLink );
                    
                    $recs = mysql_fetch_assoc( $results );
                    $rowTotal += $recs['count'];
                 
                    if ( $format == 'dw' ) {
                        print '^  ' . number_format( $recs['count'] ) . ' ';
                    }
                    else {
                        print '<td align="right"><b>' . number_format( $recs['count'] ) . '</b></td>' . "\n";
                    }
                }
            }
            
            if ( $format == 'dw' ) {
                print '^  ' . number_format( $rowTotal ) . ' ^' . "\n\n";
            }
            else {
                print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                print '</tr>' . "\n";
                print '</table><br>' . "\n";
            }
            
            // If tracking by library is enabled, sub-total by library.
            if ( $this->configProg['useLibrary'] == '1' ) {
                foreach ( $libraries as $libraryId=>$libraryDesc ) {
                    if ( is_numeric( $libraryId )) {
                        
                        if ( $format == 'dw' ) {
                            print '==== ' . $libraryDesc . ' ====' . "\n\n";
                            print '^  ';
                            foreach ( $levels as $levelId=>$levelDesc ) {
                                print '^  ' . $levelDesc . '  ';
                            }
                            print '^  Total  ^' . "\n";
                        }
                        else {
                            print '<table align="center" cellpadding="7" border="4">' . "\n";
                            print '<tr align="center" bgcolor="black">' . "\n";
                            print '<td colspan="' . $colSpan . '"><font color="white"><b>' . $libraryDesc . '</b></font></td>' . "\n";
                            print '</tr>' . "\n";
                            
                            print '<tr align="center" bgcolor="black">' . "\n";
                            print '<td><font color="white"><b></b></font></td>' . "\n";
                            foreach ( $levels as $levelId=>$levelDesc ) {
                                print '<td><font color="white">' . $levelDesc . '</font></td>' . "\n";
                            }
                            print '<td><font color="white"><b>Total</b></font></td>' . "\n";
                            print '</tr>' . "\n";
                        }
                        
                        foreach ( $schools as $schoolId=>$schoolDesc ) {
                            if ( is_numeric( $schoolId )) {
                                
                                if ( $format == 'dw' ) {
                                    print '| ' . $schoolDesc . '  ';
                                }
                                else {
                                    print '<tr>' . "\n";
                                    print '<td>' . $schoolDesc . '</td>' . "\n";
                                }
                                
                                $rowTotal = '0';
                                foreach ($levels as $levelId=>$levelDesc ) {
                                    if ( is_numeric( $levelId )) {
                                        
                                        $sql = "SELECT COUNT(*) AS 'count'
                                            FROM `record`, `reader`
                                            WHERE record.reader_id = reader.reader_id
                                            AND reader.school_id = $schoolId
                                            AND reader.library_id = $libraryId
                                            AND record.level_id = $levelId
                                            LIMIT 1;";
                                        $results = mysql_query( $sql, $dbLink );
                                        
                                        $recs = mysql_fetch_assoc( $results );
                                        $rowTotal += $recs['count'];
                                     
                                        if ( $format == 'dw' ) {
                                            print '|  ' . number_format( $recs['count'] ) . ' ';
                                        }
                                        else {
                                            print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                                        }
                                    }
                                }
                                
                                if ( $format == 'dw' ) {
                                    print '^  ' . number_format( $rowTotal ) . ' ^' . "\n";
                                }
                                else {
                                    print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                                    print '</tr>' . "\n";
                                }
                            }
                        }
                        
                        // Grand total row
                        if ( $format == 'dw' ) {
                            print '^ Total  ';
                        }
                        else {
                            print '<tr>' . "\n";
                            print '<td><b>Total</b></td>' . "\n";
                        }
                        
                        $rowTotal = '0';
                        foreach ($levels as $levelId=>$levelDesc ) {
                            if ( is_numeric( $levelId )) {
                                
                                $sql = "SELECT COUNT(*) AS 'count'
                                    FROM `record`, `reader`
                                    WHERE record.reader_id = reader.reader_id
                                    AND reader.library_id = $libraryId
                                    AND record.level_id = $levelId
                                    LIMIT 1;";
                                $results = mysql_query( $sql, $dbLink );
                                
                                $recs = mysql_fetch_assoc( $results );
                                $rowTotal += $recs['count'];
                             
                                if ( $format == 'dw' ) {
                                    print '^  ' . number_format( $recs['count'] ) . ' ';
                                }
                                else {
                                    print '<td align="right"><b>' . number_format( $recs['count'] ) . '</b></td>' . "\n";
                                }
                            }
                        }
                        
                        if ( $format == 'dw' ) {
                            print '^  ' . number_format( $rowTotal ) . ' ^' . "\n\n";
                        }
                        else {
                            print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                            print '</tr>' . "\n";
                            print '</table><br>' . "\n";
                        }
                    }
                }
            }
            if ( $format == 'dw' ) {
                print '</pre>' . "\n";
            }
        }
        // Tracking by school disabled, display error message.
        else {
            print '<h2 align="center"><font color="red">Tracking by school is disabled for this program.</font></h2>' . "\n";
        }
        
    // End function countRecordsBySchool
    }
    
    
    function countRecordsByZipcode( $progId, $format ) {
        
        $libraries = $this->getLibraries();
        $levels = $this->getLevels();
        $zipcodes = $this->getZipcodes();
        $colSpan = count( $levels ) + 2;
        
        $dbLink = $this->dbReportAccess( $progId );
        
        // Tracking by zipcode enabled, so show report.
        if ( $this->configProg['useZipcode'] == '1' ) {
            print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
            print '<h2 align="center">Count of completed levels by zipcode</h2>' . "\n";
            print '<h3 align="center"> as of ' . $this->dateOffset( 'Y-m-d g:ia' ) . '</h3>' . "\n";
            
            if ( $format == 'dw' ) {
                print '<pre>' . "\n";
                print '===== Completed levels by zipcode =====' . "\n\n";
                print '==== All Libraries ====' . "\n\n";
                print '^  ';
                foreach ( $levels as $levelId=>$levelDesc ) {
                    print '^  ' . $levelDesc . '  ';
                }
                print '^  Total  ^' . "\n";
            }
            else {
                print '<table align="center" cellpadding="7" border="4">' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td colspan="' . $colSpan . '"><font color="white"><b>All Libraries</b></font></td>' . "\n";
                print '</tr>' . "\n";
                print '<tr align="center" bgcolor="black">' . "\n";
                print '<td><font color="white"><b></b></font></td>' . "\n";
                foreach ( $levels as $levelId=>$levelDesc ) {
                    print '<td><font color="white">' . $levelDesc . '</font></td>' . "\n";
                }
                print '<td><font color="white"><b>Total</b></font></td>' . "\n";
                print '</tr>' . "\n";
            }
            
            // All libraries.
            foreach ( $zipcodes as $zipcodeId=>$zipcodeDesc ) {
                if ( is_numeric( $zipcodeId )) {
                    
                    if ( $format == 'dw' ) {
                        print '| ' . $zipcodeDesc . '  ';
                    }
                    else {
                        print '<tr>' . "\n";
                        print '<td>' . $zipcodeDesc . '</td>' . "\n";
                    }
                    
                    $rowTotal = '0';
                    foreach ($levels as $levelId=>$levelDesc ) {
                        if ( is_numeric( $levelId )) {
                            
                            $sql = "SELECT COUNT(*) AS 'count'
                                FROM `record`, `reader`
                                WHERE record.reader_id = reader.reader_id
                                AND reader.zipcode_id = $zipcodeId
                                AND record.level_id = $levelId
                                LIMIT 1;";
                            $results = mysql_query( $sql, $dbLink );
                            
                            $recs = mysql_fetch_assoc( $results );
                            $rowTotal += $recs['count'];
                         
                            if ( $format == 'dw' ) {
                                print '|  ' . number_format( $recs['count'] ) . ' ';
                            }
                            else {
                                print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                            }
                        }
                    }
                    
                    if ( $format == 'dw' ) {
                        print '^  ' . number_format( $rowTotal ) . ' ^' . "\n";
                    }
                    else {
                        print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                        print '</tr>' . "\n";
                    }
                }
            }
            
            // Grand total row
            if ( $format == 'dw' ) {
                print '^ Total  ';
            }
            else {
                print '<tr>' . "\n";
                print '<td><b>Total</b></td>' . "\n";
            }
            
            $rowTotal = '0';
            foreach ($levels as $levelId=>$levelDesc ) {
                if ( is_numeric( $levelId )) {
                    
                    $sql = "SELECT COUNT(*) AS 'count'
                        FROM `record`, `reader`
                        WHERE record.reader_id = reader.reader_id
                        AND record.level_id = $levelId
                        LIMIT 1;";
                    $results = mysql_query( $sql, $dbLink );
                    
                    $recs = mysql_fetch_assoc( $results );
                    $rowTotal += $recs['count'];
                 
                    if ( $format == 'dw' ) {
                        print '^  ' . number_format( $recs['count'] ) . ' ';
                    }
                    else {
                        print '<td align="right"><b>' . number_format( $recs['count'] ) . '</b></td>' . "\n";
                    }
                }
            }
            
            if ( $format == 'dw' ) {
                print '^  ' . number_format( $rowTotal ) . ' ^' . "\n\n";
            }
            else {
                print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                print '</tr>' . "\n";
                print '</table><br>' . "\n";
            }
            
            // If tracking by library is enabled, sub-total by library.
            if ( $this->configProg['useLibrary'] == '1' ) {
                foreach ( $libraries as $libraryId=>$libraryDesc ) {
                    if ( is_numeric( $libraryId )) {
                        
                        if ( $format == 'dw' ) {
                            print '==== ' . $libraryDesc . ' ====' . "\n\n";
                            print '^  ';
                            foreach ( $levels as $levelId=>$levelDesc ) {
                                print '^  ' . $levelDesc . '  ';
                            }
                            print '^  Total  ^' . "\n";
                        }
                        else {
                            print '<table align="center" cellpadding="7" border="4">' . "\n";
                            print '<tr align="center" bgcolor="black">' . "\n";
                            print '<td colspan="' . $colSpan . '"><font color="white"><b>' . $libraryDesc . '</b></font></td>' . "\n";
                            print '</tr>' . "\n";
                            
                            print '<tr align="center" bgcolor="black">' . "\n";
                            print '<td><font color="white"><b></b></font></td>' . "\n";
                            foreach ( $levels as $levelId=>$levelDesc ) {
                                print '<td><font color="white">' . $levelDesc . '</font></td>' . "\n";
                            }
                            print '<td><font color="white"><b>Total</b></font></td>' . "\n";
                            print '</tr>' . "\n";
                        }
                        
                        foreach ( $zipcodes as $zipcodeId=>$zipcodeDesc ) {
                            if ( is_numeric( $zipcodeId )) {
                                
                                if ( $format == 'dw' ) {
                                    print '| ' . $zipcodeDesc . '  ';
                                }
                                else {
                                    print '<tr>' . "\n";
                                    print '<td>' . $zipcodeDesc . '</td>' . "\n";
                                }
                                
                                $rowTotal = '0';
                                foreach ($levels as $levelId=>$levelDesc ) {
                                    if ( is_numeric( $levelId )) {
                                        
                                        $sql = "SELECT COUNT(*) AS 'count'
                                            FROM `record`, `reader`
                                            WHERE record.reader_id = reader.reader_id
                                            AND reader.zipcode_id = $zipcodeId
                                            AND reader.library_id = $libraryId
                                            AND record.level_id = $levelId
                                            LIMIT 1;";
                                        $results = mysql_query( $sql, $dbLink );
                                        
                                        $recs = mysql_fetch_assoc( $results );
                                        $rowTotal += $recs['count'];
                                     
                                        if ( $format == 'dw') {
                                            print '|  ' . number_format( $recs['count'] ) . ' ';
                                        }
                                        else {
                                            print '<td align="right">' . number_format( $recs['count'] ) . '</td>' . "\n";
                                        }
                                    }
                                }
                                
                                if ( $format == 'dw' ) {
                                    print '^  ' . number_format( $rowTotal ) . ' ^' . "\n";
                                }
                                else {
                                    print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                                    print '</tr>' . "\n";
                                }
                            }
                        }
                        
                        // Grand total row
                        if ( $format == 'dw' ) {
                            print '^ Total  ';
                        }
                        else {
                            print '<tr>' . "\n";
                            print '<td><b>Total</b></td>' . "\n";
                        }
                        
                        $rowTotal = '0';
                        foreach ($levels as $levelId=>$levelDesc ) {
                            if ( is_numeric( $levelId )) {
                                
                                $sql = "SELECT COUNT(*) AS 'count'
                                    FROM `record`, `reader`
                                    WHERE record.reader_id = reader.reader_id
                                    AND reader.library_id = $libraryId
                                    AND record.level_id = $levelId
                                    LIMIT 1;";
                                $results = mysql_query( $sql, $dbLink );
                                
                                $recs = mysql_fetch_assoc( $results );
                                $rowTotal += $recs['count'];
                             
                                if ( $format == 'dw' ) {
                                    print '^  ' . number_format( $recs['count'] ) . ' ';
                                }
                                else {
                                    print '<td align="right"><b>' . number_format( $recs['count'] ) . '</b></td>' . "\n";
                                }
                            }
                        }
                        
                        if ( $format == 'dw' ) {
                            print '^  ' . number_format( $rowTotal ) . ' ^' . "\n\n";
                        }
                        else {
                            print '<td align="right"><b>' . number_format( $rowTotal ) . '</b></td>' . "\n";
                            print '</tr>' . "\n";
                            print '</table><br>' . "\n";
                        }
                    }
                }
            }
            if ( $format == 'dw' ) {
                print '</pre>' . "\n";
            }
        }
        // Tracking by zipcode disabled, display error message.
        else {
            print '<h2 align="center"><font color="red">Tracking by zipcode is disabled for this program.</font></h2>' . "\n";
        }
        
    // End function countRecordsByZipcode
    }


    protected function countRecordsForReader( $id ) {
        
        $dbLink = $this->dbAccess();
        
        $sql = 'SELECT COUNT(*) AS "count" FROM `record` WHERE `reader_id` = ' . $id . ' LIMIT 1;';
        
        $results = mysql_query( $sql, $dbLink );
        $count = mysql_fetch_assoc( $results );
        return ( $count['count'] );
        
    // End function countRecordsForReader
    }


    function countValidatedReadersByLibrary( $progId, $format ) {
        
        $libraries = $this->getLibraries();
        
        $dbLink = $this->dbReportAccess( $progId );
        
        print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
        print '<h2 align="center">Count of validated Readers by Library</h2>' . "\n";
        print '<h3 align="center"> as of ' . $this->dateOffset( 'Y-m-d g:ia' ) . '</h3>' . "\n";
        
        if ( $format == 'dw' ) {
            print '<pre>' . "\n";
            print '===== Validated readers by library =====' . "\n\n";
            print '^  Library  ^  Validated  ^  Unvalidated  ^' . "\n";
        }
        else {
            print '<table align="center" cellpadding="7" border="4">' . "\n";
            print '<tr align="center" bgcolor="black">' . "\n";
            print '<td><font color="white"><b>Library</b></font></td>' . "\n";
            print '<td><font color="white"><b>Validated</b></font></td>' . "\n";
            print '<td><font color="white"><b>Unvalidated</b></font></td>' . "\n";
            print '</tr>' . "\n";
        }
        
        // If tracking by library is enabled, sub-total by library.
        if ( $this->configProg['useLibrary'] == '1' ) {
            
            $totalValidated = '0';
            $totalUnvalidated = '0';
            
            foreach ( $libraries as $id=>$desc ) {
                if ( is_numeric( $id )) {
                    
                    $sql = "SELECT COUNT(*) AS 'count'
                        FROM `reader` WHERE `library_id` = $id
                        AND `date_validated` <> '0000-00-00 00:00:00'
                        LIMIT 1;";
                    
                    $results = mysql_query( $sql, $dbLink );
                    $validated = mysql_fetch_assoc( $results );
                    $totalValidated += $validated['count'];
                    
                    $sql = "SELECT COUNT(*) AS 'count'
                        FROM `reader` WHERE `library_id` = $id
                        AND `date_validated` = '0000-00-00 00:00:00'
                        LIMIT 1;";
                    
                    $results = mysql_query( $sql, $dbLink );
                    $unvalidated = mysql_fetch_assoc( $results );
                    $totalUnvalidated += $unvalidated['count'];
                   
                    if ( $format == 'dw' ) {
                        print '| ' . $desc . '  |  ' . number_format( $validated['count'] ) . ' |  ' . number_format( $unvalidated['count'] ) . ' |' . "\n";
                    }
                    else {
                        print '<tr>' . "\n";
                        print '<td>' . $desc . '</td>' . "\n";
                        print '<td align="right">' . number_format( $validated['count'] ) . '</td>' . "\n";
                        print '<td align="right">' . number_format( $unvalidated['count'] ) . '</td>' . "\n";
                        print '</tr>' . "\n";
                    }
                }
            }
            
            if ( $format == 'dw' ) {
                print '^ Total  ^  ' . number_format( $totalValidated ) . ' ^  ' . number_format( $totalUnvalidated ) . ' ^' . "\n";
            }
            else {
                print '<tr>' . "\n";
                print '<td><b>Total</b></td>' . "\n";
                print '<td align="right"><b>' . number_format( $totalValidated ) . '</b></td>' . "\n";
                print '<td align="right"><b>' . number_format( $totalUnvalidated ) . '</b></td>' . "\n";
                print '</tr>' . "\n";
                print '</table>' . "\n";
            }
            
        }
        // If tracking by library is disabled, just show the total.
        else {
            
            $sql = "SELECT COUNT(*) AS 'count'
                FROM `reader`
                WHERE `date_validated` <> '0000-00-00 00:00:00'
                LIMIT 1;";
            
            $results = mysql_query( $sql, $dbLink );
            $validated = mysql_fetch_assoc( $results );
            
            $sql = "SELECT COUNT(*) AS 'count'
                FROM `reader`
                WHERE `date_validated` = '0000-00-00 00:00:00'
                LIMIT 1;";
            
            $results = mysql_query( $sql, $dbLink );
            $unvalidated = mysql_fetch_assoc( $results );
            
            if ( $format == 'dw' ) {
                print '^ Total  ^  ' . number_format( $validated['count'] ) . ' ^  ' . number_format( $unvalidated['count'] ) . ' ^' . "\n";
            }
            else {
                print '<tr>' . "\n";
                print '<td><b>Total</b></td>' . "\n";
                print '<td align="right">' . number_format( $validated['count'] ) . '</td>' . "\n";
                print '<td align="right">' . number_format( $unvalidated['count'] ) . '</td>' . "\n";
                print '</tr>' . "\n";
                print '</table>' . "\n";
            }
            
        }
        if ( $format == 'dw' ) {
            print '</pre>' . "\n";
        }
        
    // End function countValidatedReadersByLibrary
    }
    
    
    protected function dateOffset( $format, $date='' ) {
        
        // If no date specified, set to now.
        if ( empty ( $date )) {
            $date = strtotime( 'now' );
        }
        
        if ( $this->configGlobal['hostDateOffset'] == '0' ) {
            return( date( $format, $date ));
        }
        else {
            return( date( $format, strtotime( $this->configGlobal['hostDateOffset'], $date )));
        }
        
    // End function dateOffset
    }
    
    
    protected function dbAccess() {
        
        // Create & return DB link using configProg access credentials.
        $dbLink = mysql_connect( $this->configGlobal['dbHost'], $this->configGlobal['dbUser'], $this->configGlobal['dbPasswd'] );
        mysql_select_db($this->configProg['dbName'], $dbLink);
        return( $dbLink );
        
    // End function dbAccess
    }
    
    
    protected function dbConfigAccess() {
        
        // Create & return DB link using configGlobal access credentials.
        $dbLink = mysql_connect( $this->configGlobal['dbHost'], $this->configGlobal['dbUser'], $this->configGlobal['dbPasswd'] );
        mysql_select_db( $this->configGlobal['dbConfig'], $dbLink );
        return( $dbLink );
        
    // End function dbConfigAccess
    }
    
    
    protected function dbReportAccess( $progId ) {
        
        //$progConfig = $this->getProgConfig( $progId );
        
        // Create & return DB link using configGlobal access credentials.
        $dbLink = mysql_connect( $this->configGlobal['dbHost'], $this->configGlobal['dbUser'], $this->configGlobal['dbPasswd'] );
        mysql_select_db( $this->configGlobal['db' . $progId], $dbLink );
        return( $dbLink );
        
    // End function dbReportAccess
    }


    function deleteRegistrationForm( $form, $progId, $id ) {
        
        $dbData = $this->getRegistration( $id );
        $warningMssg = '<h2 align="center"><font color="red">Warning!<br>About to delete registration & completed levels for:</font></h2>';
        $registrationInfo = '<h3>' . $dbData['first_name'] . ' ' . $dbData['last_name'] . ' ' . $dbData['phone'] . ' (Reader ID: ' . $dbData['reader_id'] . ')</h3>';
        
        print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
        
        // Warning message & reader info, must be inside the form.
        $form->addElement( 'html', $warningMssg );
        $form->addElement( 'html', $registrationInfo );
        
        // Buttons.
        $buttons[] = $form->createElement( 'submit', 'btnDelete', 'DELETE' );
        $buttons[] = $form->createElement( 'submit', 'btnDelete', 'CANCEL');
        $form->addGroup( $buttons, NULL, NULL, '&nbsp;&nbsp;|&nbsp;&nbsp;' );
        
    // End function deleteRegistrationForm.
    }


    function displayPublicIndex() {
        
        if (( $this->dateOffset( 'Y-m-d' ) >= $this->configGlobal['indexStart'] ) and ( $this->dateOffset( 'Y-m-d' ) <= $this->configGlobal['indexEnd'] )) {
                return ( 1 );
        }
        else {
            return ( 0 );
        }
        
    // End function displayPublicIndex
    }


    function exportDataForm( $form, $progId ) {
        
        print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
        print '<h3 align="center">Data Export</h3>' . "\n";
        
        print '<p>This page allows you to download reader and completed level data
            in CSV format, suitable for import into Open Office, MS Excel or another
            spreadsheet program.</p>' . "\n";
            
        print '<p>Reader data contains registration information for each reader:
            first name, last name, age, phone, home library, etc.  For this data,
            each reader has one record.</p>' . "\n";
            
        print '<p>Level data contains completed level information: level description,
            date completed AND all the registration information for the reader.
            For this data, each reader will have one record for each level completed.</p>' . "\n";
            
        print '<p>For more information about all fields included and how you might
            use this data, please see the "Raw data exports"
            <a href="http://www.readingrecord.org/" target="_blank">Wiki</a> page.</p>' . "\n";
            
        print '<p><b>NOTE:</b> It may take awhile to export data for sites with a
            large number of records (40,000+), so please be patient.  You\'ll
            see a dialog box asking you to open or save the file when processing
            is complete.</p>' . "\n";
        
        // Form header.
        $form->addElement( 'header', 'Header', 'Export Data:' );
        
        // Buttons.
        $buttons[] = $form->createElement( 'submit', 'btnSubmit', 'Reader Data' );
        $buttons[] = $form->createElement( 'submit', 'btnSubmit', 'Level Data');
        $form->addGroup( $buttons, NULL, NULL, '&nbsp;&nbsp;|&nbsp;&nbsp;' );
        
    // End function exportDataForm
    }
    
    
    protected function exportDownload( $file ) {
        
        // Load PHP PEAR download module
        require_once 'HTTP/Download.php';
        
        $dl = new HTTP_Download();
        $dl->setFile( $file );
        $dl->setContentDisposition( HTTP_DOWNLOAD_ATTACHMENT, basename( $file ));
        $dl->setContentType( 'application/x-octetstream' );
        $dl->setLastModified( time() );
        $dl->setCache( 'false' );
        $dl->setCacheControl( 'private', '0' );
        $dl->send();
        
        // Delete file from server.
        // NOTE: Sometimes the portion of the page *after* the download (mostly
        // the /div tag & footer) winds up in the downloaded file, even though it
        // displays correctly.  I can't reproduce this at will & the sleep seems
        // to be helping thus far, so I'll leave it as-is for now.
        sleep( 5 );
        unlink( $file );
        
    // End function exportDownload
    }
    
    
    function exportReaders( $progId ) {
        
        $dbLink = $this->dbReportAccess( $progId );
        
        $fieldDesc = array( 'reader_id',
                            'last_name',
                            'first_name',
                            'phone',
                            'completed_levels',
                            'library_desc',
                            'age_desc',
                            'city_desc',
                            'zipcode_desc',
                            'email',
                            'barcode',
                            'grade_desc',
                            'school_desc',
                            'date_added',
                            'date_updated',
                            'date_validated',
                            'reg_ip',
                            'staff_notes'
                           );
        
        $sql = "SELECT
                    reader_id,
                    UNIX_TIMESTAMP(date_added) AS 'date_added',
                    UNIX_TIMESTAMP(date_updated) AS 'date_updated',
                    reg_ip,
                    reg_host,
                    library_id,
                    first_name,
                    last_name,
                    phone,
                    age_id,
                    city_id,
                    zipcode_id,
                    email,
                    barcode,
                    grade_id,
                    school_id,
                    UNIX_TIMESTAMP(date_validated) AS 'date_validated',
                    notes
                FROM
                    `reader`
                ORDER BY
                    `last_name`,
                    `first_name`,
                    `phone`;";
        $results = mysql_query( $sql, $dbLink );
        
        // Create CSV file based on hostname & program ID.
        $file = '/tmp/' . $_SERVER['HTTP_HOST'] . '_' . $this->progId . '_readers_' . $this->dateOffset( 'Y-m-d' ) . '.csv';
        $out = fopen( $file , 'wb' );
        
        print '<pre>' . "\n";
        fputcsv( $out, $fieldDesc );
        while ( $readerRow = mysql_fetch_assoc( $results )) {
            
            // Count records (completed levels) for reader
            $readerRow['completed_levels'] = $this->countRecordsForReader( $readerRow['reader_id'] );
            
            if ( $readerRow['date_added'] > '0' ) {
                $readerRow['date_added'] = $this->dateOffset( 'Y-m-d g:ia', $readerRow['date_added'] );
            }
            else {
                $readerRow['date_added'] = '';
            }
            
            if ( $readerRow['date_updated'] > '0' ) {
                $readerRow['date_updated'] = $this->dateOffset( 'Y-m-d g:ia', $readerRow['date_updated'] );
            }
            else {
                $readerRow['date_updated'] = '';
            }
            
            if ( $readerRow['date_validated'] > '0' ) {
                $readerRow['date_validated'] = $this->dateOffset( 'Y-m-d g:ia', $readerRow['date_validated'] );
            }
            else {
                $readerRow['date_validated'] = '';
            }
            
            $readerRow['library_desc'] = $this->xlateLibraryId( $readerRow['library_id'] );
            $readerRow['age_desc'] = $this->xlateAgeId( $readerRow['age_id'] );
            $readerRow['city_desc'] = $this->xlateCityId( $readerRow['city_id'] );
            $readerRow['zipcode_desc'] = $this->xlateZipcodeId( $readerRow['zipcode_id'] );
            $readerRow['grade_desc'] = $this->xlateGradeId( $readerRow['grade_id'] );
            $readerRow['school_desc'] = $this->xlateSchoolId( $readerRow['school_id'] );
            
            $recdOutput = array($readerRow['reader_id'],
                                $readerRow['last_name'],
                                $readerRow['first_name'],
                                $readerRow['phone'],
                                $readerRow['completed_levels'],
                                $readerRow['library_desc'],
                                $readerRow['age_desc'],
                                $readerRow['city_desc'],
                                $readerRow['zipcode_desc'],
                                $readerRow['email'],
                                $readerRow['barcode'],
                                $readerRow['grade_desc'],
                                $readerRow['school_desc'],
                                $readerRow['date_added'],
                                $readerRow['date_updated'],
                                $readerRow['date_validated'],
                                $readerRow['reg_ip'],
                                $readerRow['notes']
                           );
            
            fputcsv( $out, $recdOutput );
        }
        print '</pre>' . "\n";
        fclose( $out );
        
        $this->exportDownload( $file );
        
    // End function exportReaders
    }
    
    
    function exportRecords( $progId ) {
        
        $dbLink = $this->dbReportAccess( $progId );
        
        $fieldDesc = array( 'reader_id',
                            'last_name',
                            'first_name',
                            'phone',
                            'level_desc',
                            'date_completed',
                            'library_desc',
                            'age_desc',
                            'city_desc',
                            'zipcode_desc',
                            'email',
                            'barcode',
                            'grade_desc',
                            'school_desc',
                            'date_added',
                            'date_updated',
                            'date_validated',
                            'reg_ip',
                            'staff_notes'
                           );
        
        $sql = "SELECT
                    reader.reader_id,
                    UNIX_TIMESTAMP(reader.date_added) AS 'date_added',
                    UNIX_TIMESTAMP(reader.date_updated) AS 'date_updated',
                    reader.reg_ip,
                    reader.reg_host,
                    reader.library_id,
                    reader.first_name,
                    reader.last_name,
                    reader.phone,
                    reader.age_id,
                    reader.city_id,
                    reader.zipcode_id,
                    reader.email,
                    reader.barcode,
                    reader.grade_id,
                    reader.school_id,
                    reader.notes,
                    UNIX_TIMESTAMP(reader.date_validated) AS 'date_validated',
                    record.level_id,
                    UNIX_TIMESTAMP(record.date_completed) AS 'date_completed'
                FROM
                    `reader`,
                    `record`
                WHERE
                    record.reader_id = reader.reader_id
                ORDER BY
                    reader.last_name,
                    reader.first_name,
                    reader.phone,
                    record.level_id;";
        $results = mysql_query( $sql, $dbLink );
        
        // Old method, dumps CSV data to screen
        //$out = fopen( 'php://output', 'w' );
        
        // New method, create CSV file based on hostname.
        $file = '/tmp/' . $_SERVER['HTTP_HOST'] . '_' . $this->progId . '_levels_' . $this->dateOffset( 'Y-m-d' ) . '.csv';
        $out = fopen( $file , 'wb' );
        
        print '<pre>' . "\n";
        fputcsv( $out, $fieldDesc );
        while ( $readerRow = mysql_fetch_assoc( $results )) {
            
            if ( $readerRow['date_added'] > '0' ) {
                $readerRow['date_added'] = $this->dateOffset( 'Y-m-d g:ia', $readerRow['date_added'] );
            }
            else {
                $readerRow['date_added'] = '';
            }
            
            if ( $readerRow['date_updated'] > '0' ) {
                $readerRow['date_updated'] = $this->dateOffset( 'Y-m-d g:ia', $readerRow['date_updated'] );
            }
            else {
                $readerRow['date_updated'] = '';
            }
            
            if ( $readerRow['date_validated'] > '0' ) {
                $readerRow['date_validated'] = $this->dateOffset( 'Y-m-d g:ia', $readerRow['date_validated'] );
            }
            else {
                $readerRow['date_validated'] = '';
            }
            
            if ( $readerRow['date_completed'] > '0' ) {
                $readerRow['date_completed'] = $this->dateOffset( 'Y-m-d g:ia', $readerRow['date_completed'] );
            }
            else {
                $readerRow['date_completed'] = '';
            }
            
            $readerRow['library_desc'] = $this->xlateLibraryId( $readerRow['library_id'] );
            $readerRow['age_desc'] = $this->xlateAgeId( $readerRow['age_id'] );
            $readerRow['city_desc'] = $this->xlateCityId( $readerRow['city_id'] );
            $readerRow['zipcode_desc'] = $this->xlateZipcodeId( $readerRow['zipcode_id'] );
            $readerRow['grade_desc'] = $this->xlateGradeId( $readerRow['grade_id'] );
            $readerRow['school_desc'] = $this->xlateSchoolId( $readerRow['school_id'] );
            $readerRow['level_desc'] = $this->xlateLevelId( $readerRow['level_id'] );
            
            $recdOutput = array($readerRow['reader_id'],
                                $readerRow['last_name'],
                                $readerRow['first_name'],
                                $readerRow['phone'],
                                $readerRow['level_desc'],
                                $readerRow['date_completed'],
                                $readerRow['library_desc'],
                                $readerRow['age_desc'],
                                $readerRow['city_desc'],
                                $readerRow['zipcode_desc'],
                                $readerRow['email'],
                                $readerRow['barcode'],
                                $readerRow['grade_desc'],
                                $readerRow['school_desc'],
                                $readerRow['date_added'],
                                $readerRow['date_updated'],
                                $readerRow['date_validated'],
                                $readerRow['reg_ip'],
                                $readerRow['notes']
                           );
            
            fputcsv( $out, $recdOutput );
            
        }
        print '</pre>' . "\n";
        fclose( $out );
        
        $this->exportDownload( $file );
        
    // End function exportRecords
    }
    
    
    protected function getAges() {
        
        $dbLink = $this->dbAccess();
        
        // Set form default/selected age.
        $ages['X'] = '---Select your age---';
        
        $sql = "SELECT `age_id`, `desc` FROM `age` ORDER BY `sort_ord`;";
        $results = mysql_query( $sql, $dbLink );
        
        while ( $ageRow = mysql_fetch_assoc( $results )) {
            $ages[$ageRow['age_id']] = $ageRow['desc'];
        }
        
        return( $ages );
        
    // End function getAges
    }


    protected function getCities() {
        
        $dbLink = $this->dbAccess();
        
        // Set form default/selected city.
        $cities['X'] = '---Select your city---';
        
        $sql = "SELECT `city_id`, `desc` FROM `city` ORDER BY `sort_ord`;";
        $results = mysql_query( $sql, $dbLink );
        
        while ( $cityRow = mysql_fetch_assoc( $results )) {
            $cities[$cityRow['city_id']] = $cityRow['desc'];
        }
        
        return( $cities );
        
    // End function getCities
    }


    protected function getGrades() {
        
        $dbLink = $this->dbAccess();
        
        // Set form default/selected grade.    
        $grades['X'] = '---Select your grade---';
        
        $sql = "SELECT `grade_id`, `desc` FROM `grade` ORDER BY `sort_ord`;";
        $results = mysql_query($sql, $dbLink);
        
        while ( $gradeRow = mysql_fetch_assoc( $results )) {
            $grades[$gradeRow['grade_id']] = $gradeRow['desc'];
        }
        
        return( $grades );
        
    // End function getGrades
    }
    
    
    protected function getLevels() {
        
        $dbLink = $this->dbAccess();
        
        $sql = "SELECT `level_id`, `desc` FROM `level` ORDER BY `level_id`;";
        $results = mysql_query($sql, $dbLink);
        
        while ( $levelRow = mysql_fetch_assoc( $results )) {
            $levels[$levelRow['level_id']] = $levelRow['desc'];
        }
        
        return( $levels );
        
    // End function getLevels
    }
    
    
    protected function getLibraries() {
        
        $dbLink = $this->dbAccess();
        
        // Set form default/selected library.    
        $libraries['X'] = '---Select your home library---';
        
        $sql = "SELECT `library_id`, `desc` FROM `library` ORDER BY `sort_ord`;";
        $results = mysql_query($sql, $dbLink);
        
        while ( $libraryRow = mysql_fetch_assoc( $results )) {
            $libraries[$libraryRow['library_id']] = $libraryRow['desc'];
        }
        
        return( $libraries );
        
    // End function getLibraries
    }

    protected function getProgConfig( $progId ) {
        
        $dbLink = $this->dbConfigAccess();
        
        $sql = "SELECT * FROM `program` WHERE `progId` = " . $progId . ";";
        $results = mysql_query( $sql, $dbLink );
        $configProg = mysql_fetch_assoc( $results );
        
        return( $configProg );
        
    // End function getProgConfig
    }


    protected function getRegistration( $id ) {
        
        $dbLink = $this->dbAccess();
        
        $sql = "SELECT *, UNIX_TIMESTAMP(`date_validated`) AS date_validated_unix_timestamp FROM `reader` WHERE `reader_id` = '" . $id . "' LIMIT 1;";
        
        $results = mysql_query( $sql );
        $dbData = mysql_fetch_assoc( $results );
        
        return( $dbData );
        
    // End function getRegistration
    }

    
    protected function getSchools() {
        
        $dbLink = $this->dbAccess();
        
        // Set form default/selected school.    
        $schools['X'] = '---Select your school---';
        
        $sql = "SELECT `school_id`, `desc` FROM `school` ORDER BY `sort_ord`;";
        $results = mysql_query($sql, $dbLink);
        
        while ( $schoolRow = mysql_fetch_assoc( $results )) {
            $schools[$schoolRow['school_id']] = $schoolRow['desc'];
        }
        
        return( $schools );
        
    // End function getSchools
    }
    
    
    protected function getZipcodes() {
        
        $dbLink = $this->dbAccess();
        
        // Set form default/selected zipcode.
        $zipcodes['X'] = '---Select your zipcode---';
        
        $sql = "SELECT `zipcode_id`, `desc` FROM `zipcode` ORDER BY `sort_ord`;";
        $results = mysql_query( $sql, $dbLink );
        
        while ( $zipcodeRow = mysql_fetch_assoc( $results )) {
            $zipcodes[$zipcodeRow['zipcode_id']] = $zipcodeRow['desc'];
        }
        
        return( $zipcodes );
        
    // End function getZipcodes
    }


    function hrOpts() {
        
        return ( $this->configGlobal['hrOpts'] );
        
    // End function hrOpts
    }
    
    
    function imageDir() {
        
        return ( $this->configGlobal['imageDir'] );
        
    // End function imageDir
    }


    function libraryName() {
        
        return ( $this->configGlobal['libraryName'] );
        
    // End function libraryName
    }


    function listAllReaders( $progId ) {
        
        $dbLink = $this->dbAccess();
        
        print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
        print '<h2 align="center">List all readers</h2>' . "\n";
        print '<h3 align="center"> as of ' . $this->dateOffset( 'Y-m-d g:ia' ) . '</h3>' . "\n";
        
        $sql = "SELECT `reader_id`, `first_name`, `last_name`, `phone`
            FROM `reader`
            ORDER BY `last_name`, `first_name`, `phone`, `reader_id`;";
            
        mysql_query( $sql, $dbLink );   
        $results = mysql_query( $sql );
        
        print '<ol>' . "\n";
        while ( $dbData = mysql_fetch_assoc( $results ) ) {
            print '<li><a href="/staff/update.php?progId=' . $progId . '&id=' . $dbData['reader_id'] . '">' . $dbData['last_name'] . ', ' . $dbData['first_name'] . ' ' . $dbData['phone'] . '</a></li>' . "\n";
        }
        print '</ol>' . "\n";
        
    // End function listAllReaders
    }


    function listPrograms() {
        
        print '<div id="publicIndexContainer"><!-- Begin publicIndexContainer div-->' . "\n";
        
        foreach ( array ( 1, 2, 3, 4, 5, 6 ) as $progId ) {
            
            // Get program configuration variables.
            $configProg = $this->getProgConfig( $progId );
            
            if (( $this->configGlobal['enable' . $progId ] == '1' ) or ( ! empty( $configProg['altURL'] ))) {
                
                // If between program start & end dates, display program info & link.
                if ( $this->allowSelfRegistration( $progId ) ) {
                    
                    print '<h3>' . $configProg['longPgrmName'] . '</h3>' . "\n";
                    if ( ! empty ( $configProg['pgrmMssg'] )) {
                       print '<h3 align="center">' . $configProg['pgrmMssg'] . "</h3>\n";
                    }
                    
                    // Program info.
                    print '<p>' . $configProg['pgrmInfo'] . '</p>' . "\n";
                    
                    // If an alternate URL has been defined, use it.
                    if ( ! empty ( $configProg['altURL'] )) {
                        print '<a href="' . $configProg['altURL'] . '">Click for information about ' . $configProg['longPgrmName'] . '</a><br />' . "\n";
                    }
                    // Otherwise, use the regular RR URL.
                    else {
                        print '<a href=/register.php?progId=' . $progId . '>Click to register for ' . $configProg['longPgrmName'] . ' (' . $configProg['pgrmMssg'] . ')</a><br />' . "\n";
                    }
                    
                    print '<hr ' . $this->hrOpts() . '>' . "\n";
                }
            }
        }
        
        print '</div><!-- End publicIndexContainer div -->' . "\n";
        
    // End function listPrograms
    }


    function pageTitle() {
        
        return ( $this->configGlobal['pageTitle'] );
        
    // End function pageTitle
    }
    
    
    function processDeleteRegistrationForm( $progId, $id, $formData ) {
        
        $dbLink = $this->dbAccess();
        
        if ( $formData['btnDelete'] == 'DELETE') {
            
            // Delete corresponding completed levels.
            $sql = "SELECT COUNT(*) AS 'count' FROM `record` WHERE `reader_id` =  '" . $id . "';";
            $results = mysql_query( $sql, $dbLink );
            $levelCount = mysql_fetch_assoc( $results );
            
            // If there are completed levels, delete them.
            if ( $levelCount > '0' ) {
                
                $sql2 = "DELETE FROM `record` WHERE `reader_id` = '" . $id . "';";
                mysql_query( $sql2, $dbLink );
                
                // If deleting level(s) failed, print error message.
                if ( mysql_affected_rows( $dbLink ) != $levelCount['count'] ) {
                    print '<p>Deleted ' . $levelCount['count'] . ' levels.</p>' . "\n";
                }
            }
            
            // Delete registration.
            $sql = "DELETE FROM `reader` WHERE `reader_id` = '" . $id . "' LIMIT 1;";
            mysql_query( $sql, $dbLink );
            
            // If registration was successfully deleted from the DB, say so!
            if ( mysql_affected_rows( $dbLink ) == '1' ) {
                print '<p>Registration and ' . $levelCount['count'] . ' completed levels deleted!</p>' . "\n";
            }
            // If deleting the registration failed, print error message
            else {
                print '<p><font color="red">Error deleting registration!</font></p>' . "\n";
                print '<p align="left">Error message: ' . mysql_error( $dbLink ) . '</p>' . "\n";
            }
            
        }
        // Cancel button clicked, return to registration page.
        else {
            header( 'Location: /staff/update.php?progId=' . $this->progId . '&id=' . $id );
            exit();
        }
        
    // End function process DeleteRegistrationForm
    }
    
    
    function processExportDataForm( $formData, $progId ) {
        
        switch( $formData['btnSubmit'] ) {
            case 'Reader Data':
                $this->exportReaders( $progId );
                break;
            case 'Level Data':
                $this->exportRecords( $progId );
                break;
            default:
                break;
        }
        
    // End function processExportDataForm
    }
    
    
    function processRandomDrawingForm( $formData, $progId ) {
        
        $dbLink = $this->dbAccess();
        
        // Remove $btnSubmit from end of $formData.
        array_pop( $formData );
        
        // We want the array keys, which indicates which items were checked.
        $checkedItems = array_keys( $formData );
        
        //var_dump( $checkedItems );
        //exit();
        
        // Separate checked items into libraries & levels.
        foreach ( $checkedItems as $item ) {
            $tokenizedItem = explode( '_', $item );
            
            //print "$tokenizedItem[0] : $tokenizedItem[1]<br/>";
            
            // Determine if item is library, level or other.
            if ( $tokenizedItem[0] == 'library' ) {
                // Add to checked libraries array.
                $checkedLibraries[] = $tokenizedItem[1];
            }
            elseif ( $tokenizedItem[0] == 'level' ) {
                // Add to checked levels array.
                $checkedLevels[] = $tokenizedItem[1];
            }
            else {
                // Unknown data, ignore.
            }
        }
        
        //print var_dump( $checkedLibraries ) . "<br/>";
        //print var_dump( $checkedLevels ) . "<br/>";
        
        // Determine if enough boxes were checked before assembling SQL.
        $enoughBoxes = '0';
        // Library field enabled, at least 1 library & 1 level must be checked.
        if ( $this->configProg['useLibrary'] == '1' ) {
            if ( isset( $checkedLibraries ) and isset( $checkedLevels )) {
                $enoughBoxes = '1';
            }
        }
        // Library field disabled, at least 1 level must be checked.
        elseif ( $this->configProg['useLibrary'] == '0' ) {
            if ( isset( $checkedLevels )) {
                $enoughBoxes = '1';
            }
        }
        
        //print "Boxes: $enoughBoxes<br/>";
        
        if ( $enoughBoxes == '1' ) {
            
            // Construct partial SQL for checked libraries, if any.
            
            if ( isset( $checkedLibraries )) {
                
                // Copy $checkedLibraries, as we need the data later but will lose the first element.
                $checkedLibrariesCopy = $checkedLibraries;
                
                // Grab first checked level & assemble partial SQL.
                $librarySQL = " `library_id` IN ('" . array_shift( $checkedLibraries ) . "'";    
                
                // If more than one library checked, append SQL.
                foreach ( $checkedLibraries as $id ) {
                    $librarySQL .= ", '" . $id . "'";
                }
                // Close library_id SQL IN.
                $librarySQL .= ")";    
            }
            
            // Construct partial SQL for checked level(s).
            
            // Copy $checkedLevels, as we need the data later but will lose the first element.
            $checkedLevelsCopy = $checkedLevels;
                
            // Grab first checked level & assemble partial SQL.
            $levelSQL = " `level_id` IN ('" . array_shift ( $checkedLevels ) . "'";
                
            // If more than one level checked, append SQL.
            foreach ( $checkedLevels as $id ) {
               $levelSQL .= ", '" . $id . "'";
            }
                
            // Close level_id SQL IN.
            $levelSQL .= ")";
            
            if ( $this->configProg['useLibrary'] == '1' ) {
                $sql = "SELECT reader_id FROM `record` WHERE $levelSQL AND `reader_id` IN (SELECT reader_id FROM `reader` WHERE $librarySQL);";
            }
            else {
                $sql = "SELECT reader_id FROM `record` WHERE $levelSQL;";
            }
            
            //print "$sql<br/>";
            
            // Grab readers matching query.
            $results = mysql_query( $sql, $dbLink );
            while ( $readerRow = mysql_fetch_assoc( $results )) {
                $readers[] = $readerRow['reader_id'];
                
                //print var_dump( $readerRow ) . "<br>";
            }
            
            // If at least one reader, pick one.
            if ( ! empty ( $readers )) {
                
                //print '<p>Unshuffled:</p>';
                //print var_dump( $readers );
                
                shuffle( $readers );
                
                //print '<p>Shuffled:</p>';
                //print var_dump( $readers ) . '<br><br>';
                
                $dbData = $this->getRegistration( $readers[ array_rand( $readers, 1 )] );
                
                //print '<br><br>' . var_dump( $dbData );
                
                print '<h3 align="center">' . $this->dateOffset( 'Y-m-d g:ia' ) . '</h3>' . "\n";
                print '<h2 align="center">And the winner is:</h2>' . "\n";
                print '<h2>'. $dbData['first_name'] . ' ' . $dbData['last_name'] . ' ' . $dbData['phone'] . '</h2>' . "\n";
                    if ( $this->configProg['useLibrary'] == '1' ) {
                        print '<h3>Home library: ' . $this->xlateLibraryId( $dbData['library_id'] ) . '</h3>' . "\n";
                    }
                    
                $this->staffUpdateTrack( $dbData['reader_id'] );
                
                if ( $this->configProg['useLibrary'] == '1' ) {
                    print '<p>This drawing based on the following libraries:</p>' . "\n";
                    print '<ul>' . "\n";
                    foreach ( $checkedLibrariesCopy as $id ) {
                        print '<li>' . $this->xlateLibraryId( $id ) . '</li>' . "\n";
                    }
                    print '</ul>' . "\n";
                }
                
                print '<p>This drawing based on the following level(s):</p>' . "\n";
                print '<ul>' . "\n";
                foreach ( $checkedLevelsCopy as $id ) {
                    print '<li>' . $this->xlateLevelId( $id ) . '</li>' . "\n";
                }
                print '</ul>' . "\n";
                
            }
            
            // If no completed levels, say so!
            else {
                print '<h2 align="center"><font color="red">No readers matched your selection, please try again.</font></h2>' . "\n";
            }
        }
        // Not enough boxes changes, say so!
        else {
            if ( $this->configProg['useLibrary'] == '1' ) {
                print '<h2 align="center"><font color="red">Error!  You must select at least one library and one level.</font></h2>' . "\n";
            }
            else {
                print '<h2 align="center"><font color="red">Error!  You must select at least one level.</font></h2>' . "\n";
            }
        }
        
    // End function processRandomDrawingForm
    }
    
    
    function processRegistrationForm( $formData, $progId, $mode, $user ) {
        
        // Trim leading/trailing whitespace from free text fields.  Quickform
        // doesn't seem to do this properly.
        $formData['first_name'] = trim( $formData['first_name'] );
        $formData['last_name'] = trim( $formData['last_name'] );
        $formData['barcode'] = trim( $formData['barcode'] );
        
        if (( $mode == 'new' ) or ( $mode == 'copy' )) {
            
            // If duplicate registrations between programs aren't allowed, check
            // registration before adding
            if ( $this->configGlobal['allowDups'] == '0' ) {
                $this->checkDupRegistration( $formData, $user, $progId );
            }
            
            $dbLink = $this->dbAccess();
          
            if ( $user == 'patron' ) {
                // Build a safe insert query
                $sql = sprintf( "INSERT INTO `reader`
                                ( `reg_ip`, `reg_host`, `library_id`, `first_name`, `last_name`, `phone`, `age_id`, `city_id`, `zipcode_id`, `email`, `barcode`, `grade_id`, `school_id` )
                                VALUES ( '%s', '%s', '%d', '%s', '%s', '%s', '%d', '%d', '%d', '%s', '%s', '%d', '%d' )",
                                mysql_real_escape_string( $formData['reg_ip'], $dbLink ),
                                mysql_real_escape_string( $formData['reg_host'], $dbLink ),
                                $formData['library_id'],
                                mysql_real_escape_string( $formData['first_name'], $dbLink ),
                                mysql_real_escape_string( $formData['last_name'], $dbLink ),
                                mysql_real_escape_string( $formData['phone'], $dbLink ),
                                $formData['age_id'],
                                $formData['city_id'],
                                $formData['zipcode_id'],
                                mysql_real_escape_string( $formData['email'], $dbLink ),
                                mysql_real_escape_string( $formData['barcode'], $dbLink ),
                                $formData['grade_id'],
                                $formData['school_id']
                            );
            }
            elseif ( $user == 'staff' ) {
                
                if ( $formData['date_validated_checkbox'] == '1' ) {
                    $formData['date_validated'] = date( 'Y-m-d H:i:s' );
                }
                
                // Build a safe insert query
                $sql = sprintf( "INSERT INTO `reader`
                                ( `reg_ip`, `reg_host`, `library_id`, `first_name`, `last_name`, `phone`, `age_id`, `city_id`, `zipcode_id`, `email`, `barcode`, `grade_id`, `school_id`, `date_validated` )
                                VALUES ( '%s', '%s', '%d', '%s', '%s', '%s', '%d', '%d', '%d', '%s', '%s', '%d', '%d', '%s' )",
                                mysql_real_escape_string( $formData['reg_ip'], $dbLink ),
                                mysql_real_escape_string( $formData['reg_host'], $dbLink ),
                                $formData['library_id'],
                                mysql_real_escape_string( $formData['first_name'], $dbLink ),
                                mysql_real_escape_string( $formData['last_name'], $dbLink ),
                                mysql_real_escape_string( $formData['phone'], $dbLink ),
                                $formData['age_id'],
                                $formData['city_id'],
                                $formData['zipcode_id'],
                                mysql_real_escape_string( $formData['email'], $dbLink ),
                                mysql_real_escape_string( $formData['barcode'], $dbLink ),
                                $formData['grade_id'],
                                $formData['school_id'],
                                $formData['date_validated']
                            );
            }
            
            // Add record to DB
            mysql_query( $sql, $dbLink );
            
            // If record was successfully added to the DB, say so!
            if ( mysql_affected_rows( $dbLink ) == '1' ) {
                
                $dbData = $this->getRegistration( mysql_insert_id( $dbLink ));
                $this->showRegistration( $formData, $dbData, $mode, $user );
                if ( $user == 'staff'  ) {
                    $this->staffUpdateTrack( $dbData['reader_id'] );
                }
            }
            // If inserting the record failed, print error message
            else {
                if ( $user == 'patron') {
                    // Duplicate record.
                    if ( mysql_errno( $dbLink ) == '1062' ) {
                        header( 'Location:/duplicateRegistration.php' );
                        die();
                    }
                    // Unknown reason.
                    else {
                        print '<h2 align="center"><font color="red">Error!</font></h2>' . "\n";
                        print '<h3 align="center">We\'re sorry, but an error occurred while trying to register you.  Please see a staff member for assistance.</h3>' . "\n";
                        die();
                    }
                }
                elseif ( $user == 'staff' ) {
                    // Duplicate record.
                    if ( mysql_errno( $dbLink ) == '1062' ) {
                        header( 'Location:/staff/duplicateRegistration.php' );
                        die();
                    }
                    // Unknown reason.
                    else {
                        print '<h2 align="center"><font color="red">Error!</font></h2>' . "\n";
                        print '<h3 align="center">Please report the following error messages to the Reading Record team.  Thanks!</h3>' . "\n";
                        print '<p align="left">Error message: ' . mysql_error( $dbLink ) . '</p>' . "\n";
                        print '<p align="left">Error message: ' . mysql_errno( $dbLink ) . '</p>' . "\n";
                        die();
                    }
                }
                else {
                    print '<h2 align="center"><font color="red">Unknow Error!</font></h2>' . "\n";
                    print '<h3 align="center">Please report the following error messages to the Reading Record team.  Thanks!</h3>' . "\n";
                    print '<p align="left">Error message: ' . mysql_error( $dbLink ) . '</p>' . "\n";
                    print '<p align="left">Error message: ' . mysql_errno( $dbLink ) . '</p>' . "\n";
                    die();
                }
            }
        }
        elseif ( $mode == 'edit' and $user == 'staff' ) {
            
            // If copy button clicked, redirect to copy page.
            if ( $formData['btnSubmit'] == 'Copy') {
                header( 'Location: /staff/copyRegistration.php?progId='. $progId . '&id=' . $formData['reader_id'] );
                exit();
            }
            
            // If track button clicked, redirect to track completed levels page.
            if ( $formData['btnSubmit'] == 'Track') {
                header( 'Location: /staff/track.php?progId='. $progId . '&id=' . $formData['reader_id'] );
                exit();
            }
            
            // If delete button clicked, redirect to confirmation page.
            if ( $formData['btnSubmit'] == 'DELETE') {
                header( 'Location: /staff/deleteRegistration.php?progId='. $progId . '&id=' . $formData['reader_id'] );
                exit();
            }
            
            // If view or add note button clicked, redirect to notes page.
            if ( $formData['btnSubmit'] == 'Add Notes' or $formData['btnSubmit'] == 'View Notes' ) {
                header( 'Location: /staff/staffNotes.php?progId='. $progId . '&caller=reg' . '&id=' . $formData['reader_id'] );
                exit();
            }
            
            // If duplicate registrations between programs aren't allowed, check
            // registration before updating.
            if ( $this->configGlobal['allowDups'] == '0' ) {
                $this->checkDupRegistration( $formData, $user, $progId );
            }
            
            $dbLink = $this->dbAccess();
            
            $dbData = $this->getRegistration( $formData['reader_id'] );
            
            // Unset date_validated
            if (( $formData['date_validated_checkbox'] == '' ) and ( $dbData['date_validated'] != '0000-00-00 00:00:00' )) {
                $formData['date_validated'] = '0000-00-00 00:00:00';
            }
            // Set date_validated
            elseif (( $formData['date_validated_checkbox'] == '1' ) and ( $dbData['date_validated'] == '0000-00-00 00:00:00' )) {
                $formData['date_validated'] = date( 'Y-m-d H:i:s' );
            }
            // No change to date_validated
            else {
                $formData['date_validated'] = $dbData['date_validated'];
            }
            
            // Build a safe update query
            $sql = "UPDATE `reader` SET " .
                    " `library_id` = '" . $formData['library_id'] .
                    "', `first_name` = '" . mysql_real_escape_string( $formData['first_name'], $dbLink ) .
                    "', `last_name` = '" .  mysql_real_escape_string( $formData['last_name'], $dbLink ) .
                    "', `phone` = '" . mysql_real_escape_string( $formData['phone'], $dbLink ) .
                    "', `age_id` = '" . $formData['age_id'] .
                    "', `city_id` = '" . $formData['city_id'] .
                    "', `zipcode_id` = '" . $formData['zipcode_id'] .
                    "', `email` = '" . mysql_real_escape_string( $formData['email'], $dbLink ) .
                    "', `barcode` = '" . mysql_real_escape_string( $formData['barcode'], $dbLink ) .
                    "', `grade_id` = '" . $formData['grade_id'] .
                    "', `school_id` = '" . $formData['school_id'] .
                    "', `date_validated` = '" . $formData['date_validated'] .
                    "', `date_updated` = NOW()" .
                    " WHERE `reader_id` = " . $formData['reader_id'] . " LIMIT 1;";
            
            // Update record
            mysql_query( $sql, $dbLink );
            
            // If record was successfully updated, say so!
            if ( mysql_affected_rows( $dbLink ) == '1' ) {
                
                $dbData = $this->getRegistration( $formData['reader_id'] );
                $this->showRegistration( $formData, $dbData, $mode, $user );
                $this->staffUpdateTrack( $dbData['reader_id'] );
            }
            // If updating the record failed, print error message
            else {
                // Duplicate record.
                if ( mysql_errno( $dbLink ) == '1062' ) {
                    header( 'Location:/staff/duplicateRegistration.php' );
                    die();
                }
                // Unknown reason.
                else {
                    print '<h2 align="center"><font color="red">Error!</font></h2>' . "\n";
                    print '<h3 align="center">Please report the following error messages to the Reading Record team.  Thanks!</h3>' . "\n";
                    print '<p align="left">Error message: ' . mysql_error( $dbLink ) . '</p>' . "\n";
                    print '<p align="left">Error message: ' . mysql_errno( $dbLink ) . '</p>' . "\n";
                    die();
                }
            }
        }
        else {
            print "Mode? \n";
        }
        
    // End function processRegistrationForm
    }
    
    
    function processSearchForm( $formData, $progId, $mode ) {
        
        $dbLink = $this->dbAccess();
        
        $sql = "SELECT `reader_id`, `first_name`, `last_name`, `phone` FROM `reader` WHERE ";
        
        // Build search query based on which field(s) were filled out.
        if ( !empty( $formData['first_name'])) {
            $sql .= "`first_name` LIKE '%" . mysql_real_escape_string($formData['first_name'], $dbLink ) . "%' ";
        }
        if ( !empty( $formData['last_name'])) {
            if ( !empty( $formData['first_name'])) {
                $sql .= "AND ";
            }
            $sql .= "`last_name` LIKE '%" . mysql_real_escape_string($formData['last_name'], $dbLink ) . "%' ";
        }
        if ( !empty( $formData['phone'])) {
            if ( !empty( $formData['first_name']) or !empty( $formData['last_name'] )) {
                $sql .= "AND ";
            }
            $sql .= "`phone` = '" . mysql_real_escape_string( $formData['phone'], $dbLink ) . "' ";
        }
        
        // Only if barcode field enabled.
        if ( $this->configProg['useBarcode'] == '1' ) {
            if ( !empty( $formData['barcode'])) {
                if ( !empty( $formData['first_name']) or !empty( $formData['last_name'] ) or !empty( $formData['phone'] )) {
                    $sql .= "AND ";
                }
                $sql .= "`barcode` LIKE '%" . mysql_real_escape_string( $formData['barcode'], $dbLink ) . "%' ";
            }
        }
        
        $sql .= "ORDER BY `first_name`, `last_name`, `phone`, `reader_id`;";
        
        mysql_query( $sql, $dbLink );
        $recordCount = mysql_affected_rows( $dbLink );
        
        if ( $recordCount > 250 ) {
            print '<h3 align="center">Search term(s) too broad, <a href="' . $_SERVER['REQUEST_URI'] . '">please try again</a>.</h3>';
        }
        elseif ( $recordCount == 1 ) {
            $results = mysql_query( $sql );
            $dbData = mysql_fetch_assoc( $results );
            header( 'Location: /staff/' . $mode . '.php?progId=' . $progId . '&id=' . $dbData['reader_id'] );
            
        }
        elseif ( $recordCount > 0 ) {
            
            print '<h4>Search results:</h4>' . "\n";
            
            $results = mysql_query( $sql );
            while ( $dbData = mysql_fetch_assoc( $results )) {
                print '<p><a href="/staff/' . $mode . '.php?progId=' . $progId . '&id=' . $dbData['reader_id'] . '">' . $dbData['first_name'] . ' ' . $dbData['last_name'] . ' ' . $dbData['phone'] . '</a></p>';
            }
            
        }
        else {
            print '<h3 align="center">No records matching that search.</h3>';
        }
        
    // End function processSearchForm
    }
    
    
    function processStaffLogin( $formData ) {
        
        // Connect to Auth DB.
        $dbLink = $this->dbConfigAccess();
        
        // Check login credentials.
        $sql = "SELECT * FROM `login` WHERE `user_name` = '" . $formData['userName'] . "' AND `password` = '" . $formData['password'] . "';";
        $results = mysql_query( $sql );
        $numRows = mysql_num_rows( $results );
        
        // Successful login.
        if ( $numRows == 1 ) {
            
            $userData = mysql_fetch_assoc( $results );
            
            // Register a session variable (cookie).
            session_register("USER_NAME");
            $_SESSION['USER_NAME'] = $userData['user_name'];
            
            // Redirect to staff home page.
            header( 'Location: /staff' );
        }
        // Failed login, redirect back to login page & display error message.
        else {
            header( 'Location: /staff/login.php?error=1 ' );
        }
        
    // End function processStaffLogin
    }


    function processStaffNotesForm( $formData, $progId, $id, $caller ) {
        
        $dbLink = $this->dbAccess();
        
        // Save button clicked.
        if ( $formData['btnSubmit'] == 'Save') {
            
            // Build a safe update query
            $sql = "UPDATE `reader` SET " .
                    " `notes` = '" . mysql_real_escape_string( $formData['notes'], $dbLink ) .
                    "', `date_updated` = NOW()" .
                    " WHERE `reader_id` = " . $id . " LIMIT 1;";
            
            // Update record
            mysql_query( $sql, $dbLink );
        }
        // Clear button clicked.
        elseif ( $formData['btnSubmit'] == 'Clear' ) {
            $sql = "UPDATE `reader` SET `notes` = NULL, `date_updated` = NOW()" .
                    " WHERE `reader_id` = " . $id . " LIMIT 1;";
            
            // Update record
            mysql_query( $sql, $dbLink );
        }
        // Close button clicked, no changes.
        else {
            
        }
        
        if ( $caller == 'reg') {
            
            // Redisplay registration page.
            header( 'Location: /staff/update.php?progId=' . $this->progId . '&id=' . $id );
            exit();
        }
        elseif ( $caller == 'trk' ) {
            
            // Redisplay tracking page.
            header( 'Location: /staff/track.php?progId=' . $this->progId . '&id=' . $id );
            exit();
        }
        else {
            
            // Invalid caller argument, display main staff menu.
            header( 'Location: /staff' );
            exit();
        }
        
    // End function processStaffNotesForm.
    }


    function processTrackingForm( $formData, $id ) {
        
        $dbLink = $this->dbAccess();
        
        //print var_dump( $formData ) . "<br><br>";
        
        // If registration button clicked, redirect to update registration page.
            if ( $formData['btnSubmit'] == 'Registration') {
                header( 'Location: /staff/update.php?progId=' . $this->progId . '&id=' . $id );
                exit();
            }
            
        // If view or add note button clicked, redirect to notes page.
        if ( $formData['btnSubmit'] == 'Add Notes' or $formData['btnSubmit'] == 'View Notes' ) {
            header( 'Location: /staff/staffNotes.php?progId='. $this->progId . '&caller=trk' . '&id=' . $id );
            exit();
        }
        
        foreach ( $formData as $level=>$formState ) {
            if ( is_numeric( $level )) {
                //print 'Level: ' . $level . ' ' . 'State: ' . $state;
                
                // Get current record matching level, if one exists.
                $sql = "SELECT * from `record` WHERE `reader_id` = '" . $id . "' AND `level_id` = '" . $level . "' LIMIT 1;";
                mysql_query( $sql, $dbLink );
                if ( mysql_affected_rows( $dbLink ) == '1' ) {
                    $results = mysql_query( $sql, $dbLink );
                    $dbRecord = mysql_fetch_assoc( $results );
                    $dbState = '1';
                    //print var_dump( $dbRecord ) . "<br>";
                }
                else {
                    $dbState = '0';
                }
                
                // Add record if form box checked & no DB record exists.
                if ( $formState == '1' and $dbState == '0' ) {
                    $sql = "INSERT INTO `record` (`reader_id`, `level_id`) VALUES ($id, $level);";
                    mysql_query( $sql, $dbLink );
                    
                    // If record was successfully added to the DB, say so!
                    if ( mysql_affected_rows( $dbLink ) == '1' ) {
                        print '<p>Marked ' . $this->xlateLevelId( $level ) . ' as complete.</p>' . "\n";
                    }
                    // If inserting the record failed, print error message
                    else {
                        print '<p><font color="red">Error marking ' . $this->xlateLevelId( $level ) . ' as complete!</font></p>' . "\n";
                        print '<p align="left">Error message: ' . mysql_error( $dbLink ) . '</p>' . "\n";
                    }
                }
                // Delete record if form box unchecked & DB record exists.
                elseif ( $formState == '' and $dbState == '1' ) {
                    $sql = "DELETE FROM `record` WHERE `record_id` = '" . $dbRecord['record_id'] . "' LIMIT 1;";
                    mysql_query( $sql, $dbLink );
                    
                    // If record was successfully deleted from the DB, say so!
                    if ( mysql_affected_rows( $dbLink ) == '1' ) {
                        print '<p>Marked ' . $this->xlateLevelId( $level ) . ' as incomplete.</p>' . "\n";
                    }
                    // If deleting the record failed, print error message
                    else {
                        print '<p><font color="red">Error marking ' . $this->xlateLevelId( $level ) . ' as incomplete!</font></p>' . "\n";
                        print '<p align="left">Error message: ' . mysql_error( $dbLink ) . '</p>' . "\n";
                    }
                }
            }
        }
        
        // Registration NOT validated, so mark as validated & inform staff.
        if ( $this->validateRegistration( $id, 'check') == '0' ) {
            $this->validateRegistration( $id, 'set');
            print '<p>(This reader\'s registration was automatically validated upon completion of this level.)</p>' . "\n";
        }
        
        $this->staffUpdateTrack( $id );
        
    // End function processTrackingForm
    }
    
    
    function programEnabled( $progID ) {
        
        if ( $this->configGlobal['enable' . $progID] == '1' ) {
            return( 1 );
        }
        else {
            return( 0 );
        }
        
    // End function programEnabled
    }
    
    
    function randomDrawingForm( $form, $progId ) {
        
        $dbLink = $this->dbAccess();
        
        if ( empty ( $_POST )) {
            print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
            print '<h3 align="center">Random Drawing</h3>' . "\n";
            print '<p>This page allows you to select a random reader for prize drawings, etc.
                Select one or more libraries (if enabled) and one or more completed levels.</p>' . "\n";
        }
        
        // Display libraries section, if enabled.
        if ( $this->configProg['useLibrary'] == '1' ) {
            
            // Section header.
            $form->addElement( 'header', 'header', 'Select 1 or more libraries:');
            
            // Get libraries.
            $sqlLibraries = "SELECT `library_id`, `desc` FROM `library` ORDER BY `sort_ord`;";
            $resultsLibraries = mysql_query( $sqlLibraries, $dbLink );
            
            // Create form checkboxes using libraries.
            while ( $libraryRow = mysql_fetch_assoc( $resultsLibraries )) {
                $form->addElement( 'checkbox', 'library_' . $libraryRow['library_id'], NULL, '&nbsp;&nbsp;' . $libraryRow['desc'] );
            }
        }
        
        // Section header.
        $form->addElement( 'header', 'header', 'Select 1 or more levels:');
        
        // Get levels.
        $sqlLevels = "SELECT `level_id`, `desc`, `info` FROM `level` ORDER BY `level_id`;";
        $resultsLevels = mysql_query( $sqlLevels, $dbLink );
        
        // Create form checkboxes using levels.
        while ( $levelRow = mysql_fetch_assoc( $resultsLevels )) {
            $form->addElement( 'checkbox', 'level_' . $levelRow['level_id'], NULL, '&nbsp;&nbsp;' . $levelRow['desc'] . ' (' . $levelRow['info'] . ')' );
        }
        
        $form->addElement( 'submit', 'btnSubmit', 'Draw' );
        
    // End function randomDrawingForm
    }
    
    
    function registrationForm( $form, $mode, $user, $id ) {
        
        if ( $mode == 'new' ) {
            $defaults['library_id'] = 'X';
            $defaults['age_id'] = 'X';
            $defaults['city_id'] = 'X';
            $defaults['zipcode_id'] = 'X';
            $defaults['grade_id'] = 'X';
            $defaults['school_id'] = 'X';
            if ( isset ( $this->configProg['phoneAreaCode'] ) ) {
                $defaults['phone'] = $this->configProg['phoneAreaCode'];
            }
            $form->setDefaults( $defaults );
            
            // Hidden form elements for program ID, registration IP & hostname.
            $form->addElement( 'hidden', 'prog_id', $this->progId );
            $form->addElement( 'hidden', 'reg_ip', $_SERVER['REMOTE_ADDR'] );
            $form->addElement( 'hidden', 'reg_host', $_SERVER['HTTP_HOST'] );
            
            // Form header & submit button text
            $formHeaderText = 'New Registration';
            $submitButtonText = 'Register!';
        }
        elseif ( $mode == 'edit' ) {
            $dbData = $this->getRegistration( $id );
            $form->setDefaults( $dbData );
            $form->addElement( 'hidden', 'reader_id' );
            
            // Form header & submit button text
            $formHeaderText = 'Update Registration';
            $submitButtonText = 'Save';
            
            //print var_dump ( $dbData );
        }
        elseif ( $mode == 'copy') {
            $dbData = $this->getRegistration( $id );
            
            // Set first name, age, email, barcode, grade & school back to default to minimize input errors.
            $defaults['first_name'] = '';
            $defaults['age_id'] = 'X';
            $defaults['email'] = '';
            $defaults['barcode'] = '';
            $defaults['grade_id'] = 'X';
            $defaults['school_id'] = 'X';
            
            $form->setDefaults( $dbData );
            $form->addElement( 'hidden', 'reader_id' );
            
            // Hidden form elements for program ID, registration IP & hostname.
            $form->addElement( 'hidden', 'prog_id', $this->progId );
            $form->addElement( 'hidden', 'reg_ip', $_SERVER['REMOTE_ADDR'] );
            $form->addElement( 'hidden', 'reg_host', $_SERVER['HTTP_HOST'] );
            
            // Form header & submit button text
            $formHeaderText = 'Copy Registration';
            $submitButtonText = 'Register!';
        }
        
        print '<h2 align="center">' . $this->configProg['longPgrmName'] . "</h2>\n";
        if ( ! empty ( $this->configProg['pgrmMssg'] )) {
            print '<h3 align="center">' . $this->configProg['pgrmMssg'] . "</h3>\n";
        }
        
        // Form header.
        $form->addElement( 'header', 'Header', $formHeaderText );
        
        // Home library.
        if ( $this->configProg['useLibrary'] == '1' ) {
            $libraries = $this->getLibraries();
            $form->addElement('select', 'library_id', 'Home library: ', $libraries);
            $form->addRule('library_id', 'Please select your home library.', 'required');
            $form->addRule('library_id', 'Please select your home library.', 'numeric');
        }
        
        // "Personal Info" header
        if ( $this->configProg['usePersonalHeader'] == '1') {
            $form->addElement( 'header', 'Header', 'Personal Info' );
        }
        
        // First name field & validation rules.
        $form->addElement( 'text', 'first_name', 'First Name: ' );
        $form->addRule( 'first_name', 'Please enter your first name.', 'required' );
        $form->addRule( 'first_name', 'Please use letters only.', 'regex', '/^[a-z\-\'\"\ \(\)]*$/i' );
        $form->applyFilter( 'first_name', 'trim' );
        
        // Last name field & validation rules.
        $form->addElement( 'text', 'last_name', 'Last Name: ' );
        $form->addRule( 'last_name', 'Please enter your last name.', 'required' );
        $form->addRule( 'last_name', 'Please use letters only.', 'regex', '/^[a-z\-\'\"\ \(\)]*$/i' );
        $form->applyFilter( 'last_name', 'trim' );
        
        // Phone field & validation rules.
        // Using 7 digits.  Set label & regex.
        if ( $this->configProg['phoneDigits'] == '7' ) {
            $phoneLabel = 'Phone (nnn-nnnn): ';
            $phoneRegex = '/^\d\d\d\-\d\d\d\d$/';
        }
        // Using 10 digits.  Set label & regex.
        else {
            $phoneLabel = 'Phone (nnn-nnn-nnnn): ';
            $phoneRegex = '/^\d\d\d\-\d\d\d\-\d\d\d\d$/';
        }
        $form->addElement( 'text', 'phone', $phoneLabel );
        $form->addRule( 'phone', 'Please enter your phone number.', 'required' );
        $form->addRule( 'phone', $this->configProg['phoneError'], 'regex', $phoneRegex );
        $form->applyFilter( 'phone', 'trim' );
        
        // Age.
        if ( $this->configProg['useAge'] == '1' ) {
            $ages = $this->getAges();
            $form->addElement('select', 'age_id', 'Age: ', $ages);
            $form->addRule('age_id', 'Please select your age.', 'required');
            $form->addRule('age_id', 'Please select your age.', 'numeric');
        }
        
        // City.
        if ( $this->configProg['useCity'] == '1' ) {
            $cities = $this->getCities();
            $form->addElement('select', 'city_id', 'City: ', $cities);
            $form->addRule('city_id', 'Please select your city.', 'required');
            $form->addRule('city_id', 'Please select your city.', 'numeric');
        }
        
        // Zipcode.
        if ( $this->configProg['useZipcode'] == '1' ) {
            $zipcodes = $this->getZipcodes();
            $form->addElement('select', 'zipcode_id', 'Zipcode: ', $zipcodes);
            $form->addRule('zipcode_id', 'Please select your Zipcode.', 'required');
            $form->addRule('zipcode_id', 'Please select your Zipcode.', 'numeric');
        }
        
        // E-mail.
        if ( $this->configProg['useEmail'] == '1' ) {
            // Field required
            if ( $this->configProg['requireEmail'] == '1' ) {
                $form->addElement('text', 'email', 'E-mail address: ');
                $form->addRule('email', 'Please enter your e-mail address.', 'required');
                $form->addRule('email', 'Please use a valid e-mail address.', 'email');
            }
            // Field optional
            else {
                $form->addElement('text', 'email', 'E-mail address: ' );
                $form->addRule('email', 'Please use a valid e-mail address.', 'email' );
            }
        }
        
        // Barcode.
        if ( $this->configProg['useBarcode'] == '1' ) {
            // Field required
            if ( $this->configProg['requireBarcode'] == '1' ) {
                $form->addElement('text', 'barcode', 'Library barcode: ');
                $form->addRule('barcode', 'Please enter your library barcode.', 'required');
                $form->applyFilter('barcode', 'trim');
            }
            // Field optional
            else {
                $form->addElement('text', 'barcode', 'Library barcode: ');
                $form->applyFilter('barcode', 'trim');
            }
        }
        
        // "School Info" header.
        if ( $this->configProg['useSchoolHeader'] == '1' ) {
            $form->addElement( 'header', 'Header', 'School Info' );
        }
        
        // Grade.
        if ( $this->configProg['useGrade'] == '1' ) {
            $grades = $this->getGrades();
            $form->addElement('select', 'grade_id', $this->configProg['gradeLabel'], $grades);
            $form->addRule('grade_id', 'Please select your grade.', 'required');
            $form->addRule('grade_id', 'Please select your grade.', 'numeric');    
        }
        
        // School.
        if ( $this->configProg['useSchool'] == '1' ) {
            $schools = $this->getSchools();
            $form->addElement('select', 'school_id', $this->configProg['schoolLabel'], $schools);
            $form->addRule('school_id', 'Please select your school.', 'required');
            $form->addRule('school_id', 'Please select your school.', 'numeric');
        }
        
        // Registration validated (staff only).
        if (( $mode == 'new' or $mode == 'copy' ) and ( $user == 'staff' )) {
            $defaults['date_validated_checkbox'] = '1';
            $form->setDefaults( $defaults );
            $form->addElement('advcheckbox', 'date_validated_checkbox', 'Registration validated:');
        }
        elseif (( $mode == 'edit') and ( $user == 'staff' )) {
            if ( $dbData['date_validated'] > 0 ) {
                $defaults['date_validated_checkbox'] = '1';
                //$defaults['date_validated'] = $dbData['date_validated'];
                $form->setDefaults( $defaults );
                $validate[] = $form->createElement( 'advcheckbox', 'date_validated_checkbox', NULL );
                $validate[] = $form->createElement( 'static', NULL, NULL, $this->dateOffset( 'Y-m-d g:ia', $dbData['date_validated_unix_timestamp'] ));
                $form->addGroup( $validate, NULL, 'Registration Validated: ', '&nbsp;&nbsp;' );
            }
            else {
                $form->addElement('advcheckbox', 'date_validated_checkbox', 'Registration validated:');
            }
        }
        
        // If in edit mode, add update, copy & delete buttons.
        if (( $mode == 'edit' ) and ( $user == 'staff' )) {
            $buttons[] = $form->createElement( 'submit', 'btnSubmit', $submitButtonText );
            if ( isset ( $dbData['notes'] )) {
                $buttons[] = $form->createElement( 'submit', 'btnSubmit', 'View Notes');
            }
            else {
                $buttons[] = $form->createElement( 'submit', 'btnSubmit', 'Add Notes');
            }
            $buttons[] = $form->createElement( 'submit', 'btnSubmit', 'Track');
            $buttons[] = $form->createElement( 'submit', 'btnSubmit', 'Copy');
            $buttons[] = $form->createElement( 'submit', 'btnSubmit', 'DELETE');
            $form->addGroup( $buttons, NULL, NULL, '&nbsp;&nbsp;|&nbsp;&nbsp;' );
        }
        // Else just add register button.
        else {
            $form->addElement('submit', 'btnSubmit', $submitButtonText );
        }
        
    // End function registrationForm.
    }
    
    function reportsMenu( $progId ) {
        
        print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
        print '<h3 align="center">Reports Menu</h3>' . "\n";
        
        // Create table with menu items.
        print '<table align="center" cellpadding="7" border="4">' . "\n";
        
        // Totals spacer.
        print '<tr bgcolor="black">' . "\n";
        print '<td colspan="2" align="center"><font color="white"><b>Totals</b></font></td>' . "\n";
        print '</tr>' . "\n";
        
        // Reader count row.
        print '<tr>' . "\n";
        print '<td colspan="2">' . $this->countReaders( $progId ) . ' readers</td>' . "\n";
        print '</tr>' . "\n";
        
        // Record count row.
        print '<tr>' . "\n";
        print '<td colspan="2">' . $this->countRecords( $progId ) . ' completed levels</td>' . "\n";
        print '</tr>' . "\n";
        
        // Reader reports spacer.
        print '<tr bgcolor="black">' . "\n";
        print '<td colspan="2" align="center"><font color="white"><b>Reader Reports</b></font></td>' . "\n";
        print '</tr>' . "\n";
        
        // Count validated / unvalidated readers by library.
        // This report should always be available, even if the library field is disabled.
        print '<tr>' . "\n";
        print '<td><a href="/staff/reports/countValidatedReadersByLibrary.php?progId=' . $progId . '">Count validated readers</a></td>' . "\n";
        print '<td>Validated & unvalidated readers, subtotaled by library.</td>' . "\n";
        print '</tr>' . "\n";
        
        // Count readers by library.
        // Only display if library field is enabled.
        if ( $this->configProg['useLibrary'] == '1') {
            print '<tr>' . "\n";
            print '<td><a href="/staff/reports/countReadersByLibrary.php?progId=' . $progId . '">Count readers by library</a></td>' . "\n";
            print '<td>Readers subtotaled by library.</td>' . "\n";
            print '</tr>' . "\n";
        }
        
        // Count readers by age.
        // Only display if age field is enabled.
        if ( $this->configProg['useAge'] == '1' ) {
            print '<tr>' . "\n";
            print '<td><a href="/staff/reports/countReadersByAge.php?progId=' . $progId . '">Count readers by age</a></td>' . "\n";
            print '<td>Readers counted by age, subtotaled by library.</td>' . "\n";
            print '</tr>' . "\n";
        }
        
        // Count readers by city.
        // Only display if city field is enabled.
        if ( $this->configProg['useCity'] == '1' ) {
            print '<tr>' . "\n";
            print '<td><a href="/staff/reports/countReadersByCity.php?progId=' . $progId . '">Count readers by city</a></td>' . "\n";
            print '<td>Readers counted by city, subtotaled by library.</td>' . "\n";
            print '</tr>' . "\n";
        }
        
        // Count readers by zipcode.
        // Only display if zipcode field is enabled.
        if ( $this->configProg['useZipcode'] == '1' ) {
            print '<tr>' . "\n";
            print '<td><a href="/staff/reports/countReadersByZipcode.php?progId=' . $progId . '">Count readers by zipcode</a></td>' . "\n";
            print '<td>Readers counted by zipcode, subtotaled by library.</td>' . "\n";
            print '</tr>' . "\n";
        }
        
        // Count readers by grade.
        // Only display if grade field is enabled.
        if ( $this->configProg['useGrade'] == '1' ) {
            print '<tr>' . "\n";
            print '<td><a href="/staff/reports/countReadersByGrade.php?progId=' . $progId . '">Count readers by grade</a></td>' . "\n";
            print '<td>Readers counted by grade, subtotaled by library.</td>' . "\n";
            print '</tr>' . "\n";
        }
        
        // Count readers by school.
        // Only display if school field is enabled.
        if ( $this->configProg['useSchool'] == '1' ) {
            print '<tr>' . "\n";
            print '<td><a href="/staff/reports/countReadersBySchool.php?progId=' . $progId . '">Count readers by school</a></td>' . "\n";
            print '<td>Readers counted by school, subtotaled by school.</td>' . "\n";
            print '</tr>' . "\n";
        }
        
        // Level reports spacer.
        print '<tr bgcolor="black">' . "\n";
        print '<td colspan="2" align="center"><font color="white"><b>Level Reports</b></font></td>' . "\n";
        print '</tr>' . "\n";
        
        // Count levels (records) by library.
        // Only display if library field is enabled.
        if ( $this->configProg['useLibrary'] == '1' ) {
            print '<tr>' . "\n";
            print '<td><a href="/staff/reports/countLevelsByLibrary.php?progId=' . $progId . '">Count levels by library</a></td>' . "\n";
            print '<td>Completed levels subtotaled by library.</td>' . "\n";
            print '</tr>' . "\n";
        }
        
        // Count levels (records) by level & library.
        // This report should always be available, even if the library field is disabled.
        print '<tr>' . "\n";
        print '<td><a href="/staff/reports/countLevelsByLevelAndLibrary.php?progId=' . $progId . '">Count levels by level</a></td>' . "\n";
        print '<td>Completed levels counted by level, subtotaled by library.</td>' . "\n";
        print '</tr>' . "\n";
        
        // Count levels (records) by age.
        // Only display if age field is enabled.
        if ( $this->configProg['useAge'] == '1' ) {
            print '<tr>' . "\n";
            print '<td><a href="/staff/reports/countLevelsByAge.php?progId=' . $progId . '">Count levels by age</a></td>' . "\n";
            print '<td>Completed levels counted by level & age, subtotaled by library.</td>' . "\n";
            print '</tr>' . "\n";
        }
        
        // Count levels (records) by city.
        // Only display if city field is enabled.
        if ( $this->configProg['useCity'] == '1' ) {
            print '<tr>' . "\n";
            print '<td><a href="/staff/reports/countLevelsByCity.php?progId=' . $progId . '">Count levels by city</a></td>' . "\n";
            print '<td>Completed levels counted by level & age, subtotaled by library.</td>' . "\n";
            print '</tr>' . "\n";
        }
        
        // Count levels (records) by zipcode.
        // Only display if zipcode field is enabled.
        if ( $this->configProg['useZipcode'] == '1' ) {
            print '<tr>' . "\n";
            print '<td><a href="/staff/reports/countLevelsByZipcode.php?progId=' . $progId . '">Count levels by zipcode</a></td>' . "\n";
            print '<td>Completed levels counted by level & zipcode, subtotaled by library.</td>' . "\n";
            print '</tr>' . "\n";
        }
        
        // Count levels (records) by grade.
        // Only display if grade field is enabled.
        if ( $this->configProg['useGrade'] == '1' ) {
            print '<tr>' . "\n";
            print '<td><a href="/staff/reports/countLevelsByGrade.php?progId=' . $progId . '">Count levels by grade</a></td>' . "\n";
            print '<td>Completed levels counted by level & grade, subtotaled by library.</td>' . "\n";
            print '</tr>' . "\n";
        }
        
        // Count levels (records) by school.
        // Only display if schoold field is enabled.
        if ( $this->configProg['useSchool'] == '1' ) {
            print '<tr>' . "\n";
            print '<td><a href="/staff/reports/countLevelsBySchool.php?progId=' . $progId . '">Count levels by school</a></td>' . "\n";
            print '<td>Completed levels counted by level & school, subtotaled by libary.</td>' . "\n";
            print '</tr>' . "\n";
        }
        
        // Other functions spacer.
        print '<tr bgcolor="black">' . "\n";
        print '<td colspan="2" align="center"><font color="white"><b>Other Functions</b></font></td>' . "\n";
        print '</tr>' . "\n";
        
        // Random drawing.
        print '<tr>' . "\n";
        print '<td><a href="/staff/reports/randomDrawing.php?progId=' . $progId . '">Random drawing</a></td>' . "\n";
        print '<td>Select a random winner by level and library.</td>' . "\n";
        print '</tr>' . "\n";
        
        // Export data.
        print '<tr>' . "\n";
        print '<td><a href="/staff/reports/exportData.php?progId=' . $progId . '">Export data to CSV</a></td>' . "\n";
        print '<td>Export reader & level data to CSV.</td>' . "\n";
        print '</tr>' . "\n";
        
        print '</table>' . "\n";
       
    // End function reportsMenu
    }
    
    
    function rrVersion() {
        
        return( 'ReadingRecord release 2013-02-25, an 8C production' );
        
    // End function rrVersion
    }


    function searchForm( $form, $mode ) {
        
        print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
        if ( ! empty ( $this->configProg['pgrmMssg'] )) {
            print '<h3 align="center">' . $this->configProg['pgrmMssg'] . "</h3>\n";
        }
        if ( $mode == 'update' ) {
            print '<h3 align="center">Update Registration</h3>' . "\n";
        }
        elseif ( $mode == 'track' ) {
            print '<h3 align="center">Track Completed Levels</h3>' . "\n";
        }
        
        // Form header.
        $form->addElement( 'header', 'Header', 'Search' );
        
        // First name field & validation rules.
        $form->addElement( 'text', 'first_name', 'First Name: ' );
        $form->addRule( 'first_name', 'Please use letters only.', 'regex', '/^[a-z\-\'\"\ \(\)]*$/i' );
        $form->applyFilter( 'first_name', 'trim' );
        
        // Last name field & validation rules.
        $form->addElement( 'text', 'last_name', 'Last Name: ' );
        $form->addRule( 'last_name', 'Please use letters only.', 'regex', '/^[a-z\-\'\"\ \(\)]*$/i' );
        $form->applyFilter( 'last_name', 'trim' );
        
        // Phone field & validation rules.
        $form->addElement( 'text', 'phone', 'Phone: ' );
        $form->addRule( 'phone', 'Please use the format 123-456-7890.', 'regex', '/^\d\d\d\-\d\d\d\-\d\d\d\d$/' );
        $form->applyFilter( 'phone', 'trim' );
        
        // Barcode field & validation rules (if enabled).
        if ( $this->configProg['useBarcode'] == '1' ) {
            $form->addElement( 'text', 'barcode', 'Barcode: ');
            $form->applyFilter( 'barcode', 'trim' );
        }
        
        // Search button.
        $form->addElement('submit', 'btnSubmit', 'Search!' );
        
    // End function searchForm   
    }


    protected function showRegistration( $formData, $dbData, $mode, $user ) {
        
        if ( $user == 'patron' ) {
            print '<h2 align="center">Registration Successful!</h2>' . "\n";
            print '<p>Reader ' . $dbData['first_name'] . ' ' . $dbData['last_name'] . ' has been registered.</p>'  . "\n";
            if ( ! empty ( $this->configProg['regSuccessMssg'] )) {
                print $this->configProg['regSuccessMssg'] . "\n";
            }
            print '<p><a href="/">Click here</a> to allow others to register.</p>' . "\n";
        }
        elseif ( $user == 'staff' and  ( $mode == 'new' or $mode == 'copy' )) {
            print '<h2 align="center">Registration Successful!</h2>' . "\n";
            print '<p>Reader ' . $dbData['first_name'] . ' ' . $dbData['last_name'] . ' has been registered.</p>'  . "\n";
        }
        elseif ( $user == 'staff' and $mode == 'edit' ) {
            print '<h2 align="center">Update Successful!</h2>' . "\n";
            print '<p>Reader ' . $dbData['first_name'] . ' ' . $dbData['last_name'] . ' has been updated.</p>'  . "\n";
        }
        else {
            print '<h2 align="center">Unknown user or mode!</h2>' . "\n";
            die();
        }
        
    // End function showRegistration
    }


    function staffLogin( $form ) {
        
        // Form header.
        $form->addElement('header', 'Header', 'Please login:' );
        
        // Login name field & validation rules.
        $form->addElement( 'text', 'userName', 'User Name: ' );
        $form->addRule( 'userName', 'Please enter your user name.', 'required' );
        $form->addRule( 'userName', 'Please use letters & numbers only.', 'regex', '/^[a-z0-9\-\'\.]*$/i' );
        $form->applyFilter( 'userName', 'trim' );
        
        // Password field & validation rules.
        $form->addElement( 'password', 'password', 'Password: ' );
        $form->addRule( 'password', 'Please enter your password.', 'required' );
        //$form->addRule( 'passwd', 'Please use letters only.', 'regex', '/^[a-z\-\']*$/i' );
        $form->applyFilter( 'password', 'trim' );
        
        // Submit / login button.
        $form->addElement( 'submit', 'btnSubmit', 'Login!' );
        
    // End function staffLogin
    }
    
    
    function staffMenu() {
        
        // FIXME: Rewrite using additional loops, skip <tr> generation for disabled programs.
        
        // Create table with menu items.
        print '<table align="center" cellpadding="7" border="4">' . "\n";
        
        // Header row, programs 1 thru 3.
        print '<tr align="center" bgcolor="black">' . "\n";
        foreach ( array ( 1, 2, 3 ) as $progId ) {
            
            $configProg = $this->getProgConfig( $progId );
            
            if ( $this->configGlobal['enable' . $progId ] == '1' ) {
                print '<td><font color="white"><b>' . $configProg['shortPgrmName'] . '</b></font></td>' . "\n";
            }
        }
        print '</tr>' . "\n";
        
        // Reader count row, programs 1 thru 3.
        print '<tr>' . "\n";
        foreach ( array ( 1, 2, 3 ) as $progId ) {
            if ( $this->configGlobal['enable' . $progId ] == '1' ) {
                print '<td>' . $this->countReaders( $progId ) . ' readers</td>' . "\n";
            }
        }
        print '</tr>' . "\n";
        
        // Record (completed level) count row, programs 1 thru 3.
        print '<tr>' . "\n";
        foreach ( array ( 1, 2, 3 ) as $progId ) {
            if ( $this->configGlobal['enable' . $progId ] == '1' ) {
                print '<td>' . $this->countRecords( $progId ) . ' completed levels</td>' . "\n";
            }
        }
        print '</tr>' . "\n";
        
        // New registration links, programs 1 thru 3.
        print '<tr>' . "\n";
        foreach ( array ( 1, 2, 3 ) as $progId ) {
            if ( $this->configGlobal['enable' . $progId ] == '1' ) {
                print '<td><a href="/staff/register.php?progId=' . $progId . '">Add New Registration</a></td>' . "\n";
            }
        }
        print '</tr>' . "\n";
        
        // Update registration links, programs 1 thru 3.
        print '<tr>' . "\n";
        foreach ( array ( 1, 2, 3 ) as $progId ) {
            if ( $this->configGlobal['enable' . $progId ] == '1' ) {
                print '<td><a href="/staff/search.php?progId=' . $progId . '&mode=update">Update Registration</a></td>' . "\n";
            }
        }
        print '</tr>' . "\n";
        
        // Update level links, programs 1 thru 3.
        print '<tr>' . "\n";
        foreach ( array ( 1, 2, 3 ) as $progId ) {
            if ( $this->configGlobal['enable' . $progId ] == '1' ) {
                print '<td><a href="/staff/search.php?progId=' . $progId . '&mode=track">Track Completed Levels</a></td>' . "\n";
            }
        }
        print '</tr>' . "\n";
     
        // List all readers, programs 1 thru 3.
        print '<tr>' . "\n";
        foreach ( array ( 1, 2, 3 ) as $progId ) {
            if ( $this->configGlobal['enable' . $progId ] == '1' ) {
                print '<td><a href="/staff/reports/listAllReaders.php?progId=' . $progId . '">List all readers</a></td>' . "\n";
            }
        }
        print '</tr>' . "\n";
        
        // Link to reports menu (if authorized), programs 1 thru 3.
        print '<tr>' . "\n";
        foreach ( array ( 1, 2, 3 ) as $progId ) {
            //if ( $this->configGlobal['enable' . $progId ] == '1' ) {
            if (( $this->configGlobal['enable' . $progId ] == '1' ) and ( $this->staffReportsAccess( $_SESSION['USER_NAME'] ))) {
                print '<td><a href="/staff/reports/reportsIndex.php?progId=' . $progId . '">Reports menu</a></td>' . "\n";
            }
        }
        print '</tr>' . "\n";
        
        // Header row, programs 4 thru 6.
        print '<tr align="center" bgcolor="black">' . "\n";
        foreach ( array ( 4, 5, 6 ) as $progId ) {
            
            $configProg = $this->getProgConfig( $progId );
            
            if ( $this->configGlobal['enable' . $progId ] == '1' ) {
                print '<td><font color="white"><b>' . $configProg['shortPgrmName'] . '</b></font></td>' . "\n";
            }
        }
        print '</tr>' . "\n";
        
        // Reader count row, programs 4 thru 6.
        print '<tr>' . "\n";
        foreach ( array ( 4, 5, 6 ) as $progId ) {
            if ( $this->configGlobal['enable' . $progId ] == '1' ) {
                print '<td>' . $this->countReaders( $progId ) . ' readers</td>' . "\n";
            }
        }
        print '</tr>' . "\n";
        
        // Record (completed level) count row, programs 4 thru 6.
        print '<tr>' . "\n";
        foreach ( array ( 4, 5, 6 ) as $progId ) {
            if ( $this->configGlobal['enable' . $progId ] == '1' ) {
                print '<td>' . $this->countRecords( $progId ) . ' completed levels</td>' . "\n";
            }
        }
        print '</tr>' . "\n";
        
        // New registration links, programs 4 thru 6.
        print '<tr>' . "\n";
        foreach ( array ( 4, 5, 6 ) as $progId ) {
            if ( $this->configGlobal['enable' . $progId ] == '1' ) {
                print '<td><a href="/staff/register.php?progId=' . $progId . '">Add New Registration</a></td>' . "\n";
            }
        }
        print '</tr>' . "\n";
        
        // Update registration links, programs 4 thru 6.
        print '<tr>' . "\n";
        foreach ( array ( 4, 5, 6 ) as $progId ) {
            if ( $this->configGlobal['enable' . $progId ] == '1' ) {
                print '<td><a href="/staff/search.php?progId=' . $progId . '&mode=update">Update Registration</a></td>' . "\n";
            }
        }
        print '</tr>' . "\n";
        
        // Update level links, programs 4 thru 6.
        print '<tr>' . "\n";
        foreach ( array ( 4, 5, 6 ) as $progId ) {
            if ( $this->configGlobal['enable' . $progId ] == '1' ) {
                print '<td><a href="/staff/search.php?progId=' . $progId . '&mode=track">Track Completed Levels</a></td>' . "\n";
            }
        }
        print '</tr>' . "\n";
     
        // List all readers, programs 4 thru 6.
        print '<tr>' . "\n";
        foreach ( array ( 4, 5, 6 ) as $progId ) {
            if ( $this->configGlobal['enable' . $progId ] == '1' ) {
                print '<td><a href="/staff/reports/listAllReaders.php?progId=' . $progId . '">List all readers</a></td>' . "\n";
            }
        }
        print '</tr>' . "\n";
        
        // Link to reports menu (if authorized), programs 4 thru 6.
        print '<tr>' . "\n";
        foreach ( array ( 4, 5, 6 ) as $progId ) {
            //if ( $this->configGlobal['enable' . $progId ] == '1' ) {
            if (( $this->configGlobal['enable' . $progId ] == '1' ) and ( $this->staffReportsAccess( $_SESSION['USER_NAME'] ))) {
                print '<td><a href="/staff/reports/reportsIndex.php?progId=' . $progId . '">Reports menu</a></td>' . "\n";
            }
        }
        print '</tr>' . "\n";
        
        print '</table>' . "\n";
        
    // End function staffMenu
    }


    function staffNotesForm( $form, $progId, $id ) {
        
        $dbData = $this->getRegistration( $id );
        
        print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
        
        // Form header for reader info.
        $form->addElement( 'header', 'readerHeader', 'Staff notes for:' );
        
        // Reader info.
        $reader = $dbData['first_name'] . ' ' . $dbData['last_name'] . ' ' . $dbData['phone'];
        $form->addElement( 'static', NULL, NULL, $reader );
        
        // Notes field.
        if ( isset ( $dbData['notes'] ) ) {
            $defaults['notes'] = $dbData['notes'];
            $form->setDefaults( $defaults );
        }
        $notesAttr = array('rows'=>5, 'cols'=>50);
        $form->addElement( 'textarea', 'notes', 'Notes: ' ,$notesAttr );
	$form->addRule( 'notes', '250 characters maximum.', 'maxlength', 250 );
        $form->applyFilter( 'notes', 'trim' );
        
        // Buttons.
        $buttons[] = $form->createElement( 'submit', 'btnSubmit', 'Save' );
        $buttons[] = $form->createElement( 'submit', 'btnSubmit', 'Close' );
        $buttons[] = $form->createElement( 'submit', 'btnSubmit', 'Clear' );
        $form->addGroup( $buttons, NULL, NULL, '&nbsp;&nbsp;|&nbsp;&nbsp;' );
        
        
    // End function staffNotes.
    }
    
    
    function staffReportsAccess( $staffLogin ) {
        
        // Connect to Auth DB.
        $dbLink = $this->dbConfigAccess();
        
        // Check reporting credentials.
        $sql = "SELECT `reports_access` FROM `login` WHERE `user_name` = '" . $staffLogin . "';";
        $results = mysql_query( $sql );
        $userData = mysql_fetch_assoc( $results );
        
        if ( $userData['reports_access'] == '1' ) {
            return( '1' );
        }
        else {
            return( '0' );
        }
        
    // End function staffReports Access.    
    }
    
    
    function staffReportsNoAccess() {
        
        print '<h2 align="center"><font color="red">Sorry, this login is not allowed to access reports.</font></h2>' . "\n";
        
    // End function staffReportsNoAccess.
    }


    function staffShortcuts() {
        
        foreach ( array ( 1, 2, 3, 4, 5, 6 ) as $progId ) {
            
            $configProg = $this->getProgConfig( $progId );
            
            if ( $this->configGlobal['enable' . $progId ] == '1' ) {
                print '<ul>';
                print '<li>' . $configProg['shortPgrmName'] .': </li>';
                print '<li>[<a href="/staff/register.php?progId=' . $progId . '">Add</a>] </li>';
                print '<li>[<a href="/staff/search.php?progId=' . $progId . '&mode=update">Update</a>] </li>';
                print '<li>[<a href="/staff/search.php?progId=' . $progId . '&mode=track">Track</a>]</li>';
                print '</ul>' . "\n";
            }
        }
        
    // End function staffShortcuts
    }


    protected function staffUpdateTrack( $id ) {
        
        // Construct URLs to update/copy record & track levels based on program ID
        print '<p align="center">' .
            '<a href="/staff/update.php?progId=' . $this->progId . '&id=' . $id . '">[Update reader]</a> | ' .
            '<a href="/staff/copyRegistration.php?progId=' . $this->progId . '&id=' . $id . '">[Copy reader]</a> | ' .
            '<a href="/staff/track.php?progId=' . $this->progId . '&id=' . $id . '">[Track levels for reader]</a>' .
            '</p>' . "\n";
     
    // End function staffUpdateTrack
    }


    function trackingForm( $form, $id ) {
        
        $dbData = $this->getRegistration( $id );
        
        print '<h2 align="center">' . $this->configProg['shortPgrmName'] . "</h2>\n";
        
        // Form header for reader info.
        $form->addElement( 'header', 'readerHeader', 'Update Levels for:' );
        
        // Reader info.
        $reader = $dbData['first_name'] . ' ' . $dbData['last_name'] . ' ' . $dbData['phone'];
        $form->addElement( 'static', NULL, NULL, $reader );
        
        // Form header for levels.
        $form->addElement( 'header', 'Header', 'Completed Levels' );
        
        // Levels.
        $dbLink = $this->dbAccess();
        $sqlLevels = "SELECT `level_id`, `desc`, `info` FROM `level` ORDER BY `level_id`;";
        $resultsLevels = mysql_query( $sqlLevels, $dbLink );
        while ( $levelRow = mysql_fetch_assoc( $resultsLevels )) {
            
            $label = $levelRow['desc'] . ': ';
            
            // Get current record matching level, if one exists.
            $sqlRecord = "SELECT `record_id`, `reader_id`, `level_id`, UNIX_TIMESTAMP(`date_completed`) AS date_completed from `record` WHERE `reader_id` = '" . $id . "' AND `level_id` = '" . $levelRow['level_id'] . "' LIMIT 1;";
            mysql_query( $sqlRecord, $dbLink );
            if ( mysql_affected_rows( $dbLink ) == '1' ) {
                $resultsRecord = mysql_query( $sqlRecord, $dbLink );
                $dbRecord = mysql_fetch_assoc( $resultsRecord );
                $info = '&nbsp;&nbsp;Completed: ' . $this->dateOffset( 'Y-m-d g:ia', $dbRecord['date_completed'] );
                //print var_dump( $dbRecord ) . "<br>";
                
                $defaults[$levelRow['level_id']] = '1';
                $form->setDefaults( $defaults );
            }
            else {
                $info = '&nbsp;&nbsp;' . $levelRow['info'];
            }
            
            $form->addElement( 'advcheckbox', $levelRow['level_id'], $label, $info );
        }
        
        // Save & switch to update registration buttons.
        $buttons[] = $form->createElement( 'submit', 'btnSubmit', 'Save');
        if ( isset ( $dbData['notes'] )) {
            $buttons[] = $form->createElement( 'submit', 'btnSubmit', 'View Notes');
        }
        else {
            $buttons[] = $form->createElement( 'submit', 'btnSubmit', 'Add Notes');
        }
        $buttons[] = $form->createElement( 'submit', 'btnSubmit', 'Registration');
        $form->addGroup( $buttons, NULL, NULL, '&nbsp;&nbsp;|&nbsp;&nbsp;' );
        
    // End function trackingForm.
    }


    function validateProgId( $progId ) {
        
        if( $this->configGlobal['enable' . $progId ] == '1' ) {
            return( '1' );
        }
        else {
            return( '0' );
        }
        
    // End function validateProgId
    }


    function validateReaderId( $id ) {
        
        if ( is_numeric( $id )) {
            $dbLink = $this->dbAccess();
            $sql = "SELECT * from `reader` WHERE `reader_id` = $id LIMIT 1;";
            $results = mysql_query( $sql, $dbLink );
            $rowCount = mysql_numrows( $results );
            
            if ( $rowCount == '1' ) {
                return( '1' );
            }
            else {
                header( 'Location: /staff' );
            }
            
        }
        else {
            header( 'Location: /staff');
        }
        
    // End function validateReaderId
    }
    
    
    protected function validateRegistration( $id, $mode ) {
        
        $dbLink = $this->dbAccess();
        $dbData = $this->getRegistration( $id );
        
        if ( $mode == 'check' ) {
            if ( $dbData['date_validated'] <> '0000-00-00 00:00:00' ) {
                return ( 1 );
            }
            else {
                return ( 0 );
            }
        }
        elseif ( $mode == 'set' ) {
                
            // SQL to update registration.
            $sql = "UPDATE `reader` SET" .
                "`date_validated` = NOW()," .
                "`date_updated` = NOW()" .
                "WHERE `reader_id` = '" . $id . "' LIMIT 1;";
            
            // Update record
            mysql_query( $sql, $dbLink );
        }
        
    // End function validateRegistration
    }

    
    protected function xlateAgeId( $ageId ) {
        
        $dbLink = $this->dbAccess();
        
        $sql = "SELECT `desc` FROM `age` WHERE `age_id` = $ageId LIMIT 1;";
        $results = mysql_query( $sql, $dbLink );
        $ageDesc = mysql_fetch_assoc( $results );
        
        return( $ageDesc['desc'] );
        
    // End function xlateAgeId
    }


    protected function xlateCityId( $cityId ) {
        
        $dbLink = $this->dbAccess();
        
        $sql = "SELECT `desc` FROM `city` WHERE `city_id` = $cityId LIMIT 1;";
        $results = mysql_query( $sql, $dbLink );
        $cityDesc = mysql_fetch_assoc( $results );
        
        return( $cityDesc['desc'] );
        
    // End function xlateCityId
    }
    
    
    protected function xlateGradeId( $gradeId ) {
        
        $dbLink = $this->dbAccess();
        
        $sql = "SELECT `desc` FROM `grade` WHERE `grade_id` = $gradeId LIMIT 1;";
        $results = mysql_query( $sql, $dbLink );
        $gradeDesc = mysql_fetch_assoc( $results );
        
        return( $gradeDesc['desc'] );
        
    // End function xlateGradeId
    }
    
    
    protected function xlateLevelId( $levelId ) {
        
        $dbLink = $this->dbAccess();
        
        $sql = "SELECT `desc` FROM `level` WHERE `level_id` = '" . $levelId . "' LIMIT 1;";
        $results = mysql_query( $sql, $dbLink );
        $levelDesc = mysql_fetch_assoc( $results );
        
        return( $levelDesc['desc'] );
        
    // End function xlateLevelId
    }
    
    
    protected function xlateLibraryId( $libraryId ) {
        
        $dbLink = $this->dbAccess();
        
        $sql = "SELECT `desc` FROM `library` WHERE `library_id` = $libraryId LIMIT 1;";
        $results = mysql_query( $sql, $dbLink );
        $libraryDesc = mysql_fetch_assoc( $results );
        
        return( $libraryDesc['desc'] );
        
    // End function xlateLibraryId
    }


    protected function xlateSchoolId( $schoolId ) {
        
        $dbLink = $this->dbAccess();
        
        $sql = "SELECT `desc` FROM `school` WHERE `school_id` = $schoolId LIMIT 1;";
        $results = mysql_query( $sql, $dbLink );
        $schoolDesc = mysql_fetch_assoc( $results );
        
        return( $schoolDesc['desc'] );
        
    // End function xlateSchoolId
    }
    
    
    protected function xlateZipcodeId( $zipcodeId ) {
        
        $dbLink = $this->dbAccess();
        
        $sql = "SELECT `desc` FROM `zipcode` WHERE `zipcode_id` = $zipcodeId LIMIT 1;";
        $results = mysql_query( $sql, $dbLink );
        $zipcodeDesc = mysql_fetch_assoc( $results );
        
        return( $zipcodeDesc['desc'] );
        
    // End function xlateZipcodeId
    }

    
// End class ReadingRecord
}

?>
