<?php

/*
Copyright (C) 2012, 2013 by the Free Software Foundation, Inc. http://www.fsf.org/

This file is part of ReadingRecord.
Created & developed by Eric Sisler <lbylnxgek@gmail.com>

ReadingRecord is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

ReadingRecord is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with ReadingRecord. If not, see http://www.gnu.org/licenses/.
*/

// Subversion: $Id: register.php 448 2013-01-04 04:17:42Z esisler $

// Load required module(s) & initialize object(s).
require_once 'ReadingRecord/classes.php';
require_once 'HTML/QuickForm.php';
$page = new ReadingRecord( $_GET['progId'] );
$form = new HTML_QuickForm( 'register', 'post', $_SERVER['REQUEST_URI'] );

// If the program ID isn't valid, redirect to the main index page.
if( $page->validateProgId( $_GET['progId'] ) != '1' ) {
   header( 'Location: /' );
   exit();
}

// If the program isn't enabled, redirect to the main index page.
if( $page->programEnabled( $_GET['progId'] ) != '1' ) {
   header( 'Location: /' );
   exit();
}

// If self-registration isn't allowed, redirect to the registration failure page.
if( $page->allowSelfRegistration( $_GET['progId'] ) != '1' ) {
    header( 'Location: /registrationFailure.php' );
}

// Standard header.
require( 'ReadingRecord/header.php' );

// Div to control registration form.
print '<div id="form"><!-- Begin form div -->' . "\n";

// Display registration form, passing form object, program ID, mode, user.
$page->registrationForm( $form, 'new', 'patron', NULL );

// If the form is valid, process the data.
if( $form->validate() ) {
    $form->freeze();
    $form->process( $page->processRegistrationForm( $_POST, $_GET['progId'], 'new', 'patron' ), false );
}

// Invalid or blank form, so display it.
else {
    $form->display();
}

print '</div><!-- End form div -->' . "\n";

// Standard footer.
require( 'ReadingRecord/footer.php' );

?>
