<?php

/*
Copyright (C) 2012, 2013 by the Free Software Foundation, Inc. http://www.fsf.org/

This file is part of ReadingRecord.
Created & developed by Eric Sisler <lbylnxgek@gmail.com>

ReadingRecord is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

ReadingRecord is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with ReadingRecord. If not, see http://www.gnu.org/licenses/.
*/

// Subversion: $Id: login.php 448 2013-01-04 04:17:42Z esisler $

// Load required module(s) & initialize object.
require_once 'ReadingRecord/classes.php';
require_once 'HTML/QuickForm.php';
$page = new ReadingRecord ( 'none' );
$form = new HTML_QuickForm( 'login', 'post', $_SERVER['REQUEST_URI'] );

// Standard header.    
require ( 'ReadingRecord/staffHeader.php' );
    
// Div to control login form.
print '<div id="form"><!-- Begin form div -->' . "\n";

print '<h2 align="center">Staff module</h2>' . "\n";

// If the previous login attempt failed, display "try again" message.
if ( isset( $_GET['error'] ) and $_GET['error'] == '1' ) {
    print '<h2 align="center"><font color="red">Invalid login, please try again!</font></h2>' . "\n";
}

// Display login form, passing form object.
$page->staffLogin( $form );

// If the form is valid, process the data.
if ( $form->validate() ) {
    $form->freeze();
    $form->process( $page->processStaffLogin( $_POST ), false );
}

// Invalid or blank form, so display it.
else {
    $form->display();
}

print '</div><!-- End form div -->' . "\n";

// Standard footer.    
require ( 'ReadingRecord/staffFooter.php' );

?>

<script language="JavaScript">
    formObj = document.login;
    formObj.userName.focus();
</script>
