<?php

/*
Copyright (C) 2012, 2013 by the Free Software Foundation, Inc. http://www.fsf.org/

This file is part of ReadingRecord.
Created & developed by Eric Sisler <lbylnxgek@gmail.com>

ReadingRecord is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

ReadingRecord is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with ReadingRecord. If not, see http://www.gnu.org/licenses/.
*/

// Subversion: $Id: exportData.php 448 2013-01-04 04:17:42Z esisler $

// Load required module(s) & initialize object.
require_once 'ReadingRecord/classes.php';
require_once 'HTML/QuickForm.php';
$page = new ReadingRecord ( $_GET['progId'] );
$form = new HTML_QuickForm( 'submit', 'post', $_SERVER['REQUEST_URI'] );

// Standard header.
require ( 'ReadingRecord/staffHeader.php' );

// If not logged in, redirect to the login page.
if( isset( $_SESSION['USER_NAME'] ) != TRUE ) {
   header( 'Location: /staff/login.php' );
   exit();
}

// If the program ID isn't valid, redirect to the staff index page.
if( $page->validateProgId( $_GET['progId'] ) != '1' ) {
   header( 'Location: /staff' );
   exit();
}

// If the program isn't enabled, redirect to the staff index page.
if( $page->programEnabled( $_GET['progId'] ) != '1' ) {
   header( 'Location: /staff' );
   exit();
}

// Div to control list display.
print '<div id="list_readers"><!-- Begin list_readers div -->' . "\n";

// Make sure user is allowed to access this report.
if ( $page->staffReportsAccess( $_SESSION['USER_NAME'] ) ) {
    
    // Display export form, passing form object & mode.
    $page->exportDataForm( $form, $_GET['progId'] );
    
    // If the form is valid, process the data.
    if ( $form->validate() ) {
        $form->freeze();
        $form->process( $page->processExportDataForm( $_POST, $_GET['progId'] ), false );
    }
    
    // Invalid or blank form, so display it.
    else {
        $form->display();
    }
    
}
// Not allowed to access report, say so!
else {
    
    $page->staffReportsNoAccess();
    
}

print '</div><!-- End list_readers div -->' . "\n";

// Standard footer.    
require ( 'ReadingRecord/staffFooter.php' );

?>
