<?php

/*
Copyright (C) 2012, 2013 by the Free Software Foundation, Inc. http://www.fsf.org/

This file is part of ReadingRecord.
Created & developed by Eric Sisler <lbylnxgek@gmail.com>

ReadingRecord is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

ReadingRecord is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with ReadingRecord. If not, see http://www.gnu.org/licenses/.
*/

// Subversion: $Id: listAllReaders.php 448 2013-01-04 04:17:42Z esisler $

// Load required module(s) & initialize object.
require_once 'ReadingRecord/classes.php';
$page = new ReadingRecord ( $_GET['progId'] );

// Standard header.
require ( 'ReadingRecord/staffHeader.php' );

// If not logged in, redirect to the login page.
if( isset( $_SESSION['USER_NAME'] ) != TRUE ) {
   header( 'Location: /staff/login.php' );
   exit();
}

// If the program ID isn't valid, redirect to the staff index page.
if( $page->validateProgId( $_GET['progId'] ) != '1' ) {
   header( 'Location: /staff' );
   exit();
}

// If the program isn't enabled, redirect to the staff index page.
if( $page->programEnabled( $_GET['progId'] ) != '1' ) {
   header( 'Location: /staff' );
   exit();
}

// Div to control list display.
print '<div id="list_readers"><!-- Begin list_readers div -->' . "\n";

// List all readers.
$page->listAllReaders( $_GET['progId'] );

// End div to control list display.
print '</div><!-- End list_readers div -->' . "\n";

// Standard footer.    
require ( 'ReadingRecord/staffFooter.php' );

?>
