<?php

/*
Copyright (C) 2012, 2013 by the Free Software Foundation, Inc. http://www.fsf.org/

This file is part of ReadingRecord.
Created & developed by Eric Sisler <lbylnxgek@gmail.com>

ReadingRecord is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

ReadingRecord is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with ReadingRecord. If not, see http://www.gnu.org/licenses/.
*/

// Subversion: $Id: search.php 448 2013-01-04 04:17:42Z esisler $

// Load required module(s) & initialize object(s).
require_once 'ReadingRecord/classes.php';
require_once 'HTML/QuickForm.php';
$page = new ReadingRecord( $_GET['progId'] );
$form = new HTML_QuickForm( 'search', 'post', $_SERVER['REQUEST_URI'] );

// Standard header.    
require ( 'ReadingRecord/staffHeader.php' );

// If not logged in, redirect to the login page.
if( isset( $_SESSION['USER_NAME'] ) != TRUE ) {
   header( 'Location: /staff/login.php' );
   exit();
}

// If the program ID isn't valid, redirect to the staff index page.
if( $page->validateProgId( $_GET['progId'] ) != '1' ) {
   header( 'Location: /staff' );
   exit();
}

// If the program isn't enabled, redirect to the staff index page.
if( $page->programEnabled( $_GET['progId'] ) != '1' ) {
   header( 'Location: /staff' );
   exit();
}

// Ensure a mode (update registration or track levels) is set.
if ( isset( $_GET['mode'] )) {
    switch( $_GET['mode'] ) {
        case 'update':
            $mode = 'update';
            break;
        case 'track':
            $mode = 'track';
            break;
        default:
            header( 'Location: /staff' );
            exit();
            break;
    }
}

// No mode set, redirect to the staff index page.
else {
    header( 'Location: /staff' );
    exit();
}

// Div to control search form.
print '<div id="form"><!-- Begin form div -->' . "\n";

// Display search form, passing form object & mode.
$page->searchForm( $form, $mode );

// If the form is valid, process the data.
if ( $form->validate() ) {
    $form->freeze();
    $form->process( $page->processSearchForm( $_POST, $_GET['progId'], $mode ), false );
}

// Invalid or blank form, so display it.
else {
    $form->display();
}

print '</div><!-- End form div -->' . "\n";

print '<p>Search tips:</p>' . "\n";
print '<ul>' . "\n";
print '<li>You can use one or all search fields.</li>' . "\n";
print '<li>You can enter a full or partial first / last name.</li>' . "\n";
print '<li>When searching by phone, you must enter the entire phone number.</li>' . "\n";
print '</ul>' . "\n";

// Standard footer.    
require ( 'ReadingRecord/staffFooter.php' );

?>

<script language="JavaScript">
    formObj = document.search;
    formObj.first_name.focus();
</script>
