<?php

/*
Copyright (C) 2012, 2013 by the Free Software Foundation, Inc. http://www.fsf.org/

This file is part of ReadingRecord.
Created & developed by Eric Sisler <lbylnxgek@gmail.com>

ReadingRecord is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

ReadingRecord is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with ReadingRecord. If not, see http://www.gnu.org/licenses/.
*/

// Subversion: $Id: staffNotes.php 448 2013-01-04 04:17:42Z esisler $

// Load required module(s) & initialize object(s).
require_once 'ReadingRecord/classes.php';
require_once 'HTML/QuickForm.php';
$page = new ReadingRecord ( $_GET['progId'] );
$form = new HTML_QuickForm( 'notesForm', 'post', $_SERVER['REQUEST_URI'] );

// Standard header.
require ( 'ReadingRecord/staffHeader.php' );

// If not logged in, redirect to the login page.
if( isset( $_SESSION['USER_NAME'] ) != TRUE ) {
   header( 'Location: /staff/login.php' );
   exit();
}

// If the program ID isn't valid, redirect to the staff index page.
if( $page->validateProgId( $_GET['progId'] ) != '1' ) {
   header( 'Location: /staff' );
   exit();
}

// If the program isn't enabled, redirect to the staff index page.
if( $page->programEnabled( $_GET['progId'] ) != '1' ) {
   header( 'Location: /staff' );
   exit();
}

// If invalid caller argument passed, redirect to staff index page.
if ( $_GET['caller'] != 'reg' and $_GET['caller'] != 'trk' ) {
    header( 'Location: /staff' );
    exit();
}

// If reader ID was passed, validate it.
if ( isset( $_GET['id'] )) {
    $page->validateReaderId( $_GET['id'] );
}
// Otherwise, redirect to the staff index page.
else {
    header( 'Location: /staff' );
    exit();
}

// Div to control registration form.
print '<div id="form"><!-- Begin form div -->' . "\n";

// Display staff notes form, passing form object, program ID & mode.
$page->staffNotesForm( $form, $_GET['progId'], $_GET['id'] );

// If the form is valid, process the data.
if ( $form->validate() ) {
    $form->freeze();
    $form->process( $page->processStaffNotesForm( $_POST, $_GET['progId'], $_GET['id'], $_GET['caller'] ));
}

// Invalid or blank form, so display it.
else {
    $form->display();
}

print '</div><!-- End form div -->' . "\n";

// Standard footer.    
require ( 'ReadingRecord/staffFooter.php' );

?>
